#COMPILE EXE
#DIM ALL
#RESOURCE "myEditor.pbr"
'#INCLUDE "Win32api.inc"
'#INCLUDE "CommCtrl.inc"
'#INCLUDE "ComDlg32.inc"
'#INCLUDE "RichEdit.inc"
#INCLUDE "myEditorAPI.inc"
#INCLUDE "myEditor.inc"
'#INCLUDE "debug.inc"

$VerNo = "2.81"
FUNCTION PBMAIN()
   LOCAL hLib, nStyle AS LONG, s AS STRING
   hLib = LoadLibrary("RICHED20.DLL"): ctrlName = "RichEdit20A" 
   IF hLib = 0 THEN
      hLib = LoadLibrary("RICHED32.DLL"): ctrlName = "RichEdit"
   END IF
   IF hLib = 0 THEN
      s = "File 'Riched20.dll' required"
      MSGBOX s, %MB_ICONWARNING, "File not Found": EXIT FUNCTION
   END IF
   CALL InitCommonControls
   nStyle = %WS_SYSMENU OR %WS_THICKFRAME OR %WS_CLIPSIBLINGS OR _
            %WS_MAXIMIZEBOX OR %WS_MINIMIZEBOX OR %WS_CAPTION    
   DIALOG NEW PIXELS, 0, "my Editor", , , 400, 400, nStyle TO hDlg
   DIALOG SHOW MODAL hDlg CALL DialogProc
   FreeLibrary hLib
END FUNCTION

CALLBACK FUNCTION DialogProc()
   LOCAL hInst, hIcon, nOpt, flags, fileNo, nStyle AS LONG 
   LOCAL fontBold, fontItalic, fontUline AS LONG
   LOCAL fontColor, BGColor, fontSize AS LONG
   LOCAL wi, ht, m, n AS LONG 
   LOCAL nTabSpaces, tabUnits AS DWORD
   LOCAL cc AS CHOOSECOLORAPI 
   LOCAL filter, f, s, ti, txt AS STRING
   STATIC helpFile AS ASCIIZ * 255

   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM pageEnd(1000)
         helpFile = CURDIR$ + "\myEditor.chm"
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "editor", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
          
         addMenubar
         addStatusbar 
          
         '------------------------------------------------------------------
         ' read preferences stored in "myEditor.ini"
         '------------------------------------------------------------------
         IF LEN(DIR$("myEditor.ini")) THEN
            fileNo = FREEFILE
            OPEN "myEditor.ini" FOR INPUT AS #fileNo
            INPUT #fileNo, fontName
            INPUT #fileNo, fontSize
            INPUT #fileNo, wordwrap
            INPUT #fileNo, editorWi
            INPUT #fileNo, editorHt
            INPUT #fileNo, findDlg
            INPUT #fileNo, backup
            INPUT #fileNo, fontBold
            INPUT #fileNo, fontItalic
            INPUT #fileNo, fontUline
            INPUT #fileNo, textColor
            INPUT #fileNo, scrnColor
            INPUT #fileNo, nTabSpaces
            CLOSE #fileNo
         END IF

         '------------------------------------------------------------------
         ' create rich edit control with proper style for wordwrap
         '------------------------------------------------------------------
         nStyle = %WS_CHILD  OR %WS_CLIPCHILDREN OR %WS_VISIBLE OR %ES_MULTILINE OR _
                  %WS_VSCROLL OR %ES_AUTOVSCROLL OR %ES_WANTRETURN OR %ES_NOHIDESEL OR %WS_TABSTOP
         IF wordwrap = 0 THEN nStyle = nStyle OR %WS_HSCROLL OR %ES_AUTOHSCROLL
         CONTROL ADD ctrlName, hDlg, %IDC_Text, "", 0, 0, 400, 400, nStyle
         CONTROL HANDLE CBHNDL, %IDC_Text TO hEdit 
         fileFmt = %SF_TEXT 
         SendMessage hEdit, %EM_LIMITTEXT, 1000000, 0  'allow 1 meg files
         SendMessage hEdit, %EM_SETOPTIONS, %ECOOP_OR, %ECO_SELECTIONBAR 'left margin selection

         '------------------------------------------------------------------
         ' setup editor window size and menu states
         '------------------------------------------------------------------
         DESKTOP GET CLIENT TO wi, ht
         IF editorWi = 0 THEN
            m = MIN(MAX(440, .80 * ht), 800): n = m
         ELSE
            m = editorWi: n = editorHt
         END IF
         DIALOG SET SIZE CBHNDL, m, n
         DIALOG SET LOC CBHNDL, (wi - m)/2, (ht - n)/2
         IF wordwrap THEN  
            MENU SET STATE hMenu, BYCMD %IDM_WordWrap, %MF_CHECKED
         END IF   
         
         '------------------------------------------------------------------
         ' initialize printer margins
         '------------------------------------------------------------------
         leftMargin   = 0.750
         rightMargin  = 0.500
         topMargin    = 0.500
         bottomMargin = 0.500

         '------------------------------------------------------------------
         'set event mask so we'll get EN_SELCHANGE and %ENM_MOUSEEVENTS notifications
         '------------------------------------------------------------------
         SendMessage hEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE OR %ENM_CHANGE
         
         '------------------------------------------------------------------
         ' Create and set an initial fixed-width font as default
         '------------------------------------------------------------------ 
         IF LEN(fontName) = 0 THEN fontName = "Courier New" 
         IF fontSize = 0 THEN fontSize = 10
         s = STRING$(fontBold, "b") + STRING$(fontItalic, "i") + STRING$(fontUline, "u")
         hFont = MakeFont(fontName, fontSize, s)
         CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 0
         setColor fontColor, 1
         IF scrnColor = 0 THEN scrnColor = %WHITE
         IF scrnColor = &H01000000 THEN scrnColor = 0
         SendMessage hEdit, %EM_SETBKGNDCOLOR, 0, scrnColor
         SendMessage hEdit, %EM_SETSEL, -1, 0
         
         '------------------------------------------------------------------
         ' set tab stops
         '------------------------------------------------------------------
         tabSpaces = nTabSpaces
         IF tabSpaces = 0 THEN tabSpaces = 8
         tabUnits = 4 * tabSpaces
         SendMessage hEdit, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)
         
         '------------------------------------------------------------------
         ' open file from command line argument
         '------------------------------------------------------------------
         thisFile = REMOVE$(COMMAND$, ANY """")
         IF LEN(thisFile) THEN openTheFile 

         '------------------------------------------------------------------
         ' - Subclass textbox for detecting navigation keys and mouse click
         '   so that the statusbar can be updated to show row and col.
         ' - set event mask to pick up text changes
         '------------------------------------------------------------------
         gOrigEditProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(subClassEditProc))
         SendMessage hEdit, %EM_SETMODIFY, 0, 0
         prnOrientation = 1  'portrait
      CASE %WM_SIZE
         DIALOG GET CLIENT CBHNDL TO wi, ht
         IF fileFmt = %SF_RTF THEN n = 45 ELSE n = 20
         CONTROL SET SIZE CBHNDL, %IDC_Text, wi, ht - n
         MoveWindow hStatusbar, 0, ht - 20, wi, 20, 1
         DIM sbParts(2) AS LONG
         sbParts(0) = wi - 150
         sbParts(1) = wi - 75
         sbParts(2) = -1
         SendMessage(hStatusbar, %SB_SETPARTS, 3, BYVAL VARPTR(sbParts(0)))
         updateStatus
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Text
               IF CBCTLMSG = %EN_CHANGE THEN
                  updateStatus
               END IF
            CASE %IDM_NewTxt, %IDM_Close
               fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
               IF fileChanged THEN
                  s = "Do you want to save the current file?"
                  ti = "Modified File" 
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
                  IF n = %IDYES THEN saveTheFile
               END IF
               rtfFile = 0: rtfEditor 0
               CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 0
               setColor textColor, 1: setBGColor scrnColor, 1
               SendMessage hEdit, %EM_SETBKGNDCOLOR, 0, scrnColor
               thisFile = "": fileFmt = %SF_TEXT: putRichEditText hEdit, ""
               MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_GRAYED OR %MF_UNCHECKED
               SendMessage(hEdit, %EM_SETMODIFY, 0, 0)
            CASE %IDM_NewRTF
               fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
               IF fileChanged THEN
                  s = "Do you want to save the current file?"
                  ti = "Modified File" 
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
                  IF n = %IDYES THEN saveTheFile
               END IF
               IF rtfFile = 0 THEN rtfEditor 1 
               thisFile = "": fileFmt = %SF_RTF: putRichEditText hEdit, ""
               setFontName "Times New Roman"
               setFontSize 12
               setEffect 0
               setColor textColor, 1: setBGColor scrnColor, 1
               MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_ENABLED OR %MF_UNCHECKED
               SendMessage(hEdit, %EM_SETMODIFY, 0, 0)
            CASE %IDM_Open
               fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
               IF fileChanged THEN
                  s = "Do you want to save the current file?"
                  ti = "Modified File" 
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
                  IF n = %IDYES THEN saveTheFile
               END IF 
               filter = "Text Files (*.txt)|*.txt|" + _
                        "Rich Text Files (*.rtf)|*.rtf|" + _
                        "All Files (*.*)|*.*"
               flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR _
                       %OFN_LONGNAMES OR %OFN_EXPLORER
               OpenFileDialog hDlg, "Open File", f, "", filter, "", flags
               IF LEN(f) = 0 THEN EXIT FUNCTION
               putRichEditText hEdit, "": 
               thisFile = f: openTheFile
               IF rtfFile THEN
                  updateRTFControls
               ELSE 'text file
                  CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 0
                  setColor textColor, 1: setBGColor scrnColor, 1 
                  InvalidateRect hEdit, BYVAL %NULL, 0
               END IF
               SendMessage(hEdit, %EM_SETMODIFY, fileChanged, 0)
            CASE %IDM_Save
               saveTheFile
            CASE %IDM_SaveAs
               saveAsFile
               CONTROL SEND CBHNDL, %IDC_Text, %EM_SETSEL, -1, 0
            CASE %IDM_PgSetup
               PageSetup 
            CASE %IDM_Preview
               printPreview
            CASE %IDM_Print
               pageNo = 0 
               printFile
            CASE %IDM_Exit
               DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDM_Undo
               CONTROL SEND CBHNDL, %IDC_Text, %EM_UNDO, 0, 0
            CASE %IDM_Cut, %IDM_Copy
               IF CBCTL = %IDM_Cut THEN n = %WM_CUT ELSE n = %WM_COPY
               CONTROL SEND CBHNDL, %IDC_Text, n, 0, 0
               IF rtfFile = 0 THEN
                  clipboard_SetText clipboard_GetText 'leave only text
               END IF
            CASE %IDM_Paste
               IF rtfFile = 0 THEN
                  clipboard_SetText clipboard_GetText 'leave only text
               END IF
               CONTROL SEND CBHNDL, %IDC_Text, %WM_PASTE, 0, 0
               txt = getRichEditText(hEdit)
               IF LEFT$(txt, 6) = "{\rtf1" THEN
                  fileFmt = %SF_RTF: rtfFile = 1
                  MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_ENABLED OR %MF_UNCHECKED
               ELSE
                  fileFmt = %SF_TEXT 
                  MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_GRAYED OR %MF_UNCHECKED
                  CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 0
                  setColor textColor, 1: setBGColor scrnColor, 1 
                  InvalidateRect hEdit, BYVAL %NULL, 0
               END IF
            CASE %IDM_SelAll
               CONTROL SEND CBHNDL, %IDC_Text, %EM_SETSEL, 0, -1
            CASE %IDM_Fonts
               fontDlg
               CONTROL SET FOCUS CBHNDL, %IDC_Text
            CASE %IDM_TabSpaces
               tabSpaces = VAL(myInput("Number of spaces:", "Tab Spaces"))
               tabUnits = 4 * tabSpaces
               SendMessage hEdit, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)
            CASE %IDM_Paragraphs     
               paragraphDlg
            CASE %IDM_Bullets
               setBullets
            CASE %IDM_WordWrap
               wordWrapView
            CASE %IDM_Strip
               stripCodes
            CASE %IDM_RTFTags
               fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
               IF fileFmt = %SF_RTF THEN 'view as text with tags
                  rtfEditor 0
                  MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_CHECKED
                  fileFmt = %SF_RTF: txt = getRichEditText(hEdit)
                  CONTROL SEND CBHNDL, %IDC_Text, %WM_SETFONT, hFont, 0
                  setColor textColor, 1: setBGColor scrnColor, 1
                  InvalidateRect hEdit, BYVAL %NULL, 0
                  fileFmt = %SF_TEXT: putRichEditText hEdit, txt
               ELSE 'view as RTF file
                  rtfEditor 1
                  MENU SET STATE hMenu, BYCMD %IDM_RTFTags, %MF_UNCHECKED
                  fileFmt = %SF_TEXT: txt = getRichEditText(hEdit)
                  fileFmt = %SF_RTF: putRichEditText hEdit, txt
                  updateRTFControls
               END IF 
               SendMessage(hEdit, %EM_SETMODIFY, fileChanged, 0)
            CASE %IDM_Preferences
               Preferences   
            CASE %IDM_Find
               myfindReplace hEdit: updateStatus
            CASE %IDM_FindNext 
               myfindReplace hEdit, 3: updateStatus
            CASE %IDM_FindPrev
               myfindReplace hEdit, -3: updateStatus
            CASE %IDM_Replace
               nOpt = myfindReplace(hEdit, 1): updateStatus
            CASE %IDM_Content
               HtmlHelp CBHNDL, helpFile, 0, 0
            CASE %IDM_About
               about
            CASE %IDC_FontNames
               IF CBCTLMSG = %CBN_SELENDOK THEN
                  COMBOBOX GET TEXT CBHNDL, %IDC_FontNames TO txt
                  setFontName txt
               END IF
            CASE %IDC_FontSizes   
               IF CBCTLMSG = %CBN_SELENDOK THEN
                  COMBOBOX GET TEXT CBHNDL, %IDC_FontSizes TO txt
                  setFontSize VAL(txt)
               END IF
            CASE %IDC_BOLD
               IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
               IF SendMessage(CBLPARAM, %BM_GETCHECK, 0, 0) THEN
                  setEffect BYVAL (getEffect OR %CFE_BOLD)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_BOLD)
               END IF
            CASE %IDC_ITALIC
               IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
               IF SendMessage(CBLPARAM, %BM_GETCHECK, 0, 0) THEN
                  setEffect BYVAL (getEffect OR %CFE_ITALIC)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_ITALIC)
               END IF
            CASE %IDC_ULINE
               IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
               IF SendMessage(CBLPARAM, %BM_GETCHECK, 0, 0) THEN
                  setEffect BYVAL (getEffect OR %CFE_UNDERLINE)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_UNDERLINE)
               END IF
            CASE %IDC_Color
               IF CBCTLMSG <> %BN_CLICKED THEN EXIT FUNCTION
               DIM lCustomColor(15) AS LOCAL LONG 'array
               cc.lStructSize  = LEN(CHOOSECOLORAPI)
               cc.hwndOwner    = hDlg  'Handle of owner window
               cc.lpCustColors = VARPTR(lCustomColor(0))
               cc.flags        = %CC_RGBINIT	
               cc.rgbResult    = getColor
               n = ChooseColor(cc)
               IF n THEN
                  fontColor = cc.rgbResult: setColor fontColor
                  CONTROL SET COLOR CBHNDL, %IDC_ColorView, fontColor, BGColor
               END IF
               CONTROL SEND CBHNDL, %IDC_Color, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
               InvalidateRect CBHNDL, BYVAL %NULL, 0
               CONTROL SET FOCUS CBHNDL, %IDC_Text
         END SELECT
      CASE %WM_NOTIFY
         IF fileFmt = %SF_RTF THEN updateRTFControls
      CASE %WM_HELP
         HtmlHelp CBHNDL, helpFile, 0, 0
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            IF NOT quitProgram THEN FUNCTION = 1: EXIT FUNCTION
            DIALOG END hPreviewDlg
         END IF
      CASE %WM_DESTROY
         DeleteObject hFont
         DeleteDC hPrnDC
   END SELECT
END FUNCTION

FUNCTION subClassEditProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL lRet AS LONG, pt AS POINTAPI, sMenu AS STRING, t AS ASCIIZ * 2
   SELECT CASE wMsg&
      CASE %WM_KEYUP 'Process navigation keybd messages and update status bar
         SELECT CASE wParm&
         CASE %VK_UP, %VK_DOWN, %VK_LEFT, %VK_RIGHT, %VK_HOME, %VK_END, %VK_PRIOR, %VK_NEXT
            updateStatus
         END SELECT
      CASE %WM_KEYDOWN
         IF wParm& = %VK_TAB THEN 'insert tab
            t = CHR$(9): SendMessage hEdit, %EM_REPLACESEL, 1, VARPTR(t)
         END IF   
      CASE %WM_LBUTTONUP
         updateStatus   
      CASE %WM_RBUTTONDOWN
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         ClientToScreen hWnd&, pt
         MENU GET TEXT hMenu, BYCMD %IDM_WordWrap TO sMenu
         MENU SET TEXT hMouseMenu, BYCMD %IDM_WordWrap, MID$(sMenu, 2)
         TrackPopupMenuEx hMouseMenu, 0, pt.x, pt.y, hDlg, BYVAL %NULL 
      CASE %WM_GETDLGCODE
         IF ISFALSE lParm& THEN 'not a message being sent to the control  
           ' Ensure that the edit control does not select its contents on receiving the focus
           lRet = CallWindowProc(gOrigEditProc, hWnd&, wMsg&, wParm&, lParm&)
           FUNCTION = lRet XOR %DLGC_HASSETSEL 'Clear the DLGC_HASSETSEL bit from lRet
           EXIT FUNCTION
         END IF
   END SELECT
   ' Pass the message on to the original window procedure
   FUNCTION = CallWindowProc(gOrigEditProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB addMenubar()
   'LOCAL s AS STRING
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu
   MENU ADD STRING, hFileMenu, "&New Text" & $TAB & "Ctrl+N", %IDM_NewTxt, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&New RTF", %IDM_NewRTF, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Close", %IDM_Close, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Open" & $TAB & "Ctrl+O", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save" & $TAB & "Ctrl+S", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "Page Set&up", %IDM_PgSetup, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Print Pre&view", %IDM_Preview, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Print" & $TAB & "Ctrl+P", %IDM_Print, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit"& $TAB & "ALT+F4", %IDM_Exit, %MF_ENABLED
   MENU ADD POPUP, hMenu, "File", hFileMenu, %MF_ENABLED
   MENU NEW POPUP TO hEditMenu
   MENU ADD STRING, hEditMenu, "&Undo" & $TAB & "Ctrl+Z", %IDM_Undo, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Cu&t" & $TAB & "Ctrl+X", %IDM_Cut, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Copy" & $TAB & "Ctrl+C", %IDM_Copy, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Paste" & $TAB & "Ctrl+V", %IDM_Paste, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Select all" & $TAB & "Ctrl+A", %IDM_SelAll, %MF_ENABLED 
   MENU ADD POPUP, hMenu, "Edit", hEditMenu, %MF_ENABLED
   MENU NEW POPUP TO hFmtMenu
   MENU ADD STRING, hFmtMenu, "&Fonts and Colors", %IDM_Fonts, %MF_ENABLED
   MENU ADD STRING, hFmtMenu, "&Strip Non-Ascii Characters", %IDM_Strip, %MF_ENABLED 
   MENU ADD STRING, hFmtMenu, "&Tab spaces", %IDM_TabSpaces, %MF_ENABLED
   MENU ADD STRING, hFmtMenu, "RTF &Bullets", %IDM_Bullets, %MF_GRAYED
   MENU ADD STRING, hFmtMenu, "RTF &Paragraphs", %IDM_Paragraphs, %MF_GRAYED
   MENU ADD POPUP, hMenu, "Format", hFmtMenu, %MF_ENABLED
   MENU NEW POPUP TO hViewMenu
   MENU ADD STRING, hViewMenu, "&Wordwrap on", %IDM_WordWrap, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&RTF tags", %IDM_RTFTags, %MF_GRAYED 
   MENU ADD STRING, hViewMenu, "-", 0, 0
   MENU ADD STRING, hViewMenu, "&Preferences", %IDM_Preferences, %MF_ENABLED 
   MENU ADD POPUP, hMenu, "View", hViewMenu, %MF_ENABLED
   MENU NEW POPUP TO hSearchMenu
   MENU ADD STRING, hSearchMenu, "&Find" & $TAB & "Ctrl+F", %IDM_Find, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "Find &Next" & $TAB & "F3", %IDM_FindNext, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "Find &Previous" & $TAB & "Shft+F3", %IDM_FindPrev, %MF_ENABLED
   MENU ADD STRING, hSearchMenu, "&Replace" & $TAB & "Ctrl+R", %IDM_Replace, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Search", hSearchMenu, %MF_ENABLED
   MENU NEW POPUP TO hHelpMenu
   MENU ADD STRING, hHelpMenu, "&Content", %IDM_Content, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %IDM_About, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Help", hHelpMenu, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
   MENU NEW POPUP TO hMouseMenu '-----------------------------------
   MENU ADD STRING, hMouseMenu, "Word wrap off", %IDM_WordWrap, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Select all", %IDM_SelAll, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Undo", %IDM_Undo, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Cut", %IDM_Cut, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Copy", %IDM_Copy, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Paste", %IDM_Paste, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Print", %IDM_Print, %MF_ENABLED
   REDIM ac(1:12) AS ACCELAPI
   ac(1).fvirt = %FVIRTKEY OR %FCONTROL
   ac(1).key = %VK_N
   ac(1).cmd =  %IDM_NewTxt
   ac(2).fvirt = %FVIRTKEY OR %FCONTROL
   ac(2).key = %VK_O
   ac(2).cmd =  %IDM_Open
   ac(3).fvirt = %FVIRTKEY OR %FCONTROL
   ac(3).key = %VK_S
   ac(3).cmd =  %IDM_Save
   ac(4).fvirt = %FVIRTKEY OR %FCONTROL
   ac(4).key = %VK_P
   ac(4).cmd =  %IDM_Print
   ac(5).fvirt = %FVIRTKEY OR %FCONTROL
   ac(5).key = %VK_Z
   ac(5).cmd =  %IDM_Undo
   ac(6).fvirt = %FVIRTKEY OR %FCONTROL
   ac(6).key = %VK_X
   ac(6).cmd =  %IDM_Cut
   ac(7).fvirt = %FVIRTKEY OR %FCONTROL
   ac(7).key = %VK_C
   ac(7).cmd =  %IDM_Copy
   ac(8).fvirt = %FVIRTKEY OR %FCONTROL
   ac(8).key = %VK_V
   ac(8).cmd =  %IDM_Paste
   ac(9).fvirt = %FVIRTKEY OR %FCONTROL
   ac(9).key = %VK_F
   ac(9).cmd =  %IDM_Find
   ac(10).fvirt = %FVIRTKEY
   ac(10).key = %VK_F3
   ac(10).cmd =  %IDM_FindNext
   ac(11).fvirt = %FVIRTKEY OR %FSHIFT
   ac(11).key = %VK_F3
   ac(11).cmd =  %IDM_FindPrev
   ac(12).fvirt = %FVIRTKEY OR %FCONTROL
   ac(12).key = %VK_R
   ac(12).cmd =  %IDM_Replace
   ACCEL ATTACH hDlg, ac() TO hAccel
END SUB

SUB addStatusbar()
   'to display string, s, in statusbar panel, n:
   '    SendMessage hStatusbar1, %SB_SETTEXT, n - 1, BYVAL STRPTR(s)
   DIM sbParts(2) AS LONG
   hStatusbar = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, hDlg, 200)
   sbParts(0) = 350
   sbParts(1) = 425
   sbParts(2) = -1
   SendMessage(hStatusbar, %SB_SETPARTS, 3, BYVAL VARPTR(sbParts(0)))
END SUB

SUB Preferences()
   LOCAL hPreferences, nStyle AS LONG, s AS STRING
   nStyle =  %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, 0, "Preferences", , , 250, 230, nStyle TO hPreferences
   s = "Save current font/colors as default" 
   CONTROL ADD CHECKBOX, hPreferences, %IDC_SaveFont, s, 20, 20, 200, 15
   s = "Save current editor window size"
   CONTROL ADD CHECKBOX, hPreferences, %IDC_EditorSize, s, 20, 45, 200, 15
   s = "Save current tab spaces"
   CONTROL ADD CHECKBOX, hPreferences, %IDC_Tabspaces, s, 20, 70, 200, 15
   s = "Word wrap setting on"
   CONTROL ADD CHECKBOX, hPreferences, %IDC_WordWrap, s, 20, 95, 200, 15
   s = "Find dialog on during searches"
   CONTROL ADD CHECKBOX, hPreferences, %IDC_FindDlg, s, 20, 120, 200, 15
   s = "Modified files backed up (.bak)"
   CONTROL ADD CHECKBOX, hPreferences, %IDC_Backup, s, 20, 144, 200, 15
   CONTROL ADD BUTTON, hPreferences, %IDOK, "&Ok", 80, 180, 80, 40
   DIALOG SHOW MODAL hPreferences CALL PreferencesProc
END SUB

CALLBACK FUNCTION PreferencesProc()
   LOCAL fileNo, saveFont, saveSize, saveTabs AS LONG
   STATIC xFontName AS STRING
   STATIC xfontSize, xwordwrap, xeditorWi, xeditorHt, xfindDlg, xbackup AS LONG
   STATIC xfontBold, xfontItalic, xfontUline, xtextColor, xscrnColor, xnTabSpaces AS LONG               
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         IF LEN(DIR$("myEditor.ini")) THEN
            fileNo = FREEFILE
            OPEN "myEditor.ini" FOR INPUT AS #fileNo
            INPUT #fileNo, xfontName
            INPUT #fileNo, xfontSize
            INPUT #fileNo, xwordwrap
            INPUT #fileNo, xeditorWi
            INPUT #fileNo, xeditorHt
            INPUT #fileNo, xfindDlg
            INPUT #fileNo, xbackup
            INPUT #fileNo, xfontBold
            INPUT #fileNo, xfontItalic
            INPUT #fileNo, xfontUline
            INPUT #fileNo, xtextColor
            INPUT #fileNo, xscrnColor
            INPUT #fileNo, xnTabSpaces
            CLOSE #fileNo
         END IF
         IF fileFmt = %SF_RTF THEN CONTROL DISABLE CBHNDL, %IDC_SaveFont
         CONTROL SET CHECK CBHNDL, %IDC_SaveFont, 0
         CONTROL SET CHECK CBHNDL, %IDC_EditorSize, 0
         CONTROL SET CHECK CBHNDL, %IDC_Tabspaces, 0
         CONTROL SET CHECK CBHNDL, %IDC_WordWrap, xwordwrap
         CONTROL SET CHECK CBHNDL, %IDC_FindDlg, xfindDlg
         CONTROL SET CHECK CBHNDL, %IDC_Backup, xbackup
      CASE %WM_COMMAND 
         IF CBCTL = %IDOK THEN
            CONTROL GET CHECK CBHNDL, %IDC_SaveFont TO saveFont
            CONTROL GET CHECK CBHNDL, %IDC_EditorSize TO saveSize
            CONTROL GET CHECK CBHNDL, %IDC_Tabspaces TO saveTabs
            CONTROL GET CHECK CBHNDL, %IDC_WordWrap TO xwordwrap
            CONTROL GET CHECK CBHNDL, %IDC_FindDlg TO xfindDlg
            CONTROL GET CHECK CBHNDL, %IDC_Backup TO xbackup
            IF saveFont THEN
               xfontName = getFontName
               xfontSize = getFontSize 
               xfontBold = SGN(getEffect AND %CFE_BOLD)
               xfontItalic = SGN(getEffect AND %CFE_ITALIC)
               xfontUline = SGN(getEffect AND %CFE_UNDERLINE)
               IF scrnColor = 0 THEN scrnColor = &H01000000
            END IF
            IF saveSize THEN DIALOG GET SIZE hDlg TO xeditorWi, xeditorHt
            IF saveTabs THEN xnTabSpaces = tabSpaces
            fileNo = FREEFILE
            OPEN "myEditor.ini" FOR OUTPUT AS #fileNo
            WRITE #fileNo, xfontName
            WRITE #fileNo, xfontSize
            WRITE #fileNo, xWordwrap
            WRITE #fileNo, xeditorWi
            WRITE #fileNo, xeditorHt
            WRITE #fileNo, xfindDlg 
            WRITE #fileNo, xbackup
            WRITE #fileNo, xfontBold
            WRITE #fileNo, xfontItalic
            WRITE #fileNo, xfontUline
            WRITE #fileNo, xtextColor
            WRITE #fileNo, xscrnColor
            WRITE #fileNo, xnTabSpaces
            CLOSE #fileNo
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT   
END FUNCTION

SUB rtfEditor(rtf AS LONG)
   LOCAL hdc, wi, ht, x, i, n, lRet, hWnd, nStyle AS LONG, s AS STRING
   DIALOG GET CLIENT hDlg TO x, ht
   CONTROL GET SIZE hDlg, %IDC_Text TO wi, x
   IF rtf THEN 'add rtf toolbar
      rtfFile = 1: fileFmt = %SF_RTF: n = %MF_ENABLED
      nStyle = %CBS_DROPDOWNLIST OR %CBS_SORT OR %WS_VSCROLL
      CONTROL SET LOC hDlg, %IDC_Text, 0, 25
      CONTROL SET SIZE hDlg, %IDC_Text, wi, ht - 45
      CONTROL ADD COMBOBOX, hDlg, %IDC_FontNames, , 2, 2, 150, 120, nStyle
      CONTROL ADD COMBOBOX, hDlg, %IDC_FontSizes, , 155, 2, 50, 120, %CBS_DROPDOWN OR %WS_VSCROLL
      CONTROL ADD BUTTON, hDlg, %IDC_Bold, "b", 210, 2, 20, 20, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE
      CONTROL ADD BUTTON, hDlg, %IDC_Italic, "i", 230, 2, 20, 20, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE
      CONTROL ADD BUTTON, hDlg, %IDC_ULine, "u", 250, 2, 20, 20, %BS_AUTOCHECKBOX OR %BS_PUSHLIKE
      CONTROL ADD BUTTON, hDlg, %IDC_Color, "", 285, 2, 40, 20, %BS_LEFT
      CONTROL ADD LABEL, hDlg, %IDC_ColorView, "Color", 287, 4, 36, 16, %SS_CENTER
      lRet = 1 'enumerate all fonts and fill font name combobox
      hDC = GetDC(%HWND_DESKTOP): hCurrentDlg = hDlg
      enumFontFamilies hDC, BYVAL %NULL, CODEPTR(enumFontFamProc), BYVAL VARPTR(lRet)
      ReleaseDC %HWND_DESKTOP, hDC
      s = getFontName
      CONTROL HANDLE hDlg, %IDC_FontSizes TO hWnd
      CONTROL SEND hDlg, %IDC_FontNames, %CB_SELECTSTRING, -1, STRPTR(s)
      enumFontSizes s, hWnd 'enumerate font sizes for current font
      s = USING$("##", getFontSize)
      CONTROL SEND hDlg, %IDC_FontSizes, %CB_SELECTSTRING, -1, STRPTR(s)
      updateRTFControls
   ELSE
      fileFmt = %SF_TEXT: n = %MF_GRAYED
      IF rtfFile THEN n = %MF_ENABLED
      CONTROL SET LOC hDlg, %IDC_Text, 0, 0
      CONTROL SET SIZE hDlg, %IDC_Text, wi, ht - 20
      FOR i = %IDC_FontNames TO %IDC_ColorView
         CONTROL KILL hDlg, i
      NEXT i
   END IF
   UpdateWindow hDlg
   MENU SET STATE hMenu, BYCMD %IDM_RTFTags, n   'enable menu item if RTF file
   MENU SET STATE hMenu, BYCMD %IDM_Bullets, n
   MENU SET STATE hMenu, BYCMD %IDM_Paragraphs, n
END SUB

SUB wordWrapView()
   'just recreate rich edit text without %WS_HSCROLL and %ES_AUTOHSCROLL styles
   LOCAL wi, ht, nStyle AS LONG
   LOCAL tabUnits AS DWORD
   LOCAL txt AS STRING 
   fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
   txt = getRichEditText(hEdit)
   CONTROL GET SIZE hDlg, %IDC_Text TO wi, ht
   CONTROL KILL hDlg, %IDC_Text
   nStyle = %WS_CHILD  OR %WS_CLIPCHILDREN OR %WS_VISIBLE OR %ES_MULTILINE OR _
            %WS_VSCROLL OR %ES_AUTOVSCROLL OR %ES_WANTRETURN OR %ES_NOHIDESEL
   IF wordwrap THEN
      wordwrap = 0 
      nStyle = nStyle OR %WS_HSCROLL OR %ES_AUTOHSCROLL
      MENU SET STATE hMenu, BYCMD %IDM_WordWrap, %MF_UNCHECKED
   ELSE
      wordwrap = 1
      MENU SET STATE hMenu, BYCMD %IDM_WordWrap, %MF_CHECKED  
   END IF
   CONTROL ADD ctrlName, hDlg, %IDC_Text, "", 0, 0, wi, ht, nStyle
   CONTROL HANDLE hDlg, %IDC_Text TO hEdit
   SendMessage hEdit, %EM_LIMITTEXT, 1000000, 0  'allow 1 meg files
   SendMessage hEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE OR %ENM_CHANGE
   tabUnits = 4 * tabSpaces
   SendMessage hEdit, %EM_SETTABSTOPS, 1, VARPTR(tabUnits)
   SendMessage hEdit, %EM_SETBKGNDCOLOR, 0, scrnColor
   IF fileFmt = %SF_TEXT THEN
      SendMessage hEdit, %WM_SETFONT, hFont, 0 
      setColor textColor, 1: setBGColor scrnColor, 1
   ELSE
      rtfEditor 1
      updateRTFControls  
   END IF 
   putRichEditText hEdit, txt
   gOrigEditProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(subClassEditProc))
   ShowWindow hEdit, %SW_RESTORE
   SendMessage hEdit, %EM_SETOPTIONS, %ECOOP_OR, %ECO_SELECTIONBAR
   SendMessage(hEdit, %EM_SETMODIFY, fileChanged, 0)
END SUB

FUNCTION getRichEditText(BYVAL hEd AS DWORD) AS STRING
   LOCAL sBuffer AS STRING, ES AS EDITSTREAM
   es.dwCookie = VARPTR(sBuffer)
   es.pfnCallback = CODEPTR(getRichEditTextCB)
   IF fileFmt = 0 THEN fileFmt = %SF_TEXT 
   SendMessage(hEd, %EM_STREAMOUT, fileFmt, VARPTR(es))
   FUNCTION = sBuffer
END FUNCTION

FUNCTION getRichEditTextCB(BYVAL dwCookie AS DWORD, BYVAL pRichEd AS BYTE PTR, _
                         BYVAL cb AS LONG, BYREF pcb AS LONG) AS LONG
   LOCAL psBuffer AS STRING PTR
   psBuffer = dwCookie
   IF cb < 1 THEN EXIT FUNCTION
   @psBuffer = @psBuffer & PEEK$(pRichEd, cb)
   pcb = cb
END FUNCTION

FUNCTION putRichEditText(BYVAL hEd AS DWORD, BYVAL sBuffer AS STRING) AS LONG
   '-------------------------------------------------------------------------------
   'let rich edit call the callback function repeatedly, reading in 4K chunks
   'of data at a time until there is no more to read.
   '-------------------------------------------------------------------------------
   LOCAL ES AS EDITSTREAM
   es.dwCookie = VARPTR(sBuffer)
   es.pfnCallback = CODEPTR(putRichEditTextCB)
   FUNCTION = SendMessage(hEd, %EM_STREAMIN, fileFmt, VARPTR(es))
END FUNCTION

FUNCTION putRichEditTextCB(BYVAL dwCookie AS DWORD, BYVAL pRichEd AS BYTE PTR, _
                      BYVAL cb AS LONG, BYREF pcb AS LONG) AS LONG
    'dwCookie used to pass ptr to string buffer holding the data to load                  
    'pRichEd is the ptr to the rich edit control buffer to receive the data
    'cb = bytes to read in chunks (4K) defined by the OS
    'pcb = bytes actually needed to be read (last chunk less than 4K)
    '-------------------------------------------------------------------------                  
    LOCAL psBuffer AS STRING PTR
    psBuffer = dwCookie
    pcb = MIN(LEN(@psBuffer), cb)
    IF pcb > 0 THEN
        POKE$ pRichEd, LEFT$(@psBuffer, pcb)
        @psBuffer = MID$(@psBuffer, pcb + 1)
    END IF
END FUNCTION

SUB openTheFile()
   LOCAL fileNo, rtfFile0 AS LONG, sBuffer AS STRING 
   fileNo = FREEFILE
   OPEN thisFile FOR BINARY ACCESS READ LOCK SHARED AS #fileNo
   IF ERR THEN 
      MSGBOX ERROR$(ERR) + "   ", %MB_ICONERROR, "File Error ": EXIT SUB
   END IF
   sBuffer = STRING$(LOF(fileNo), 0)
   GET #fileNo,, sBuffer  'load file into string buffer
   CLOSE #fileNo
   rtfFile0 = rtfFile
   IF LCASE$(LEFT$(sBuffer, 6)) = "{\rtf1" THEN rtfFile = 1 ELSE rtfFile = 0
   IF rtfFile <> rtfFile0 THEN rtfEditor rtfFile
   putRichEditText hEdit, sBuffer: updateStatus 1
   SendMessage hEdit, %EM_SETMODIFY, 0, 0
END SUB

SUB saveTheFile()
   LOCAL txt, s AS STRING
   LOCAL fileNo AS LONG
   IF LEN(thisFile) THEN
      IF backup THEN
         s = thisFile + ".bak"
         NAME thisFile AS s    
      ELSE
         KILL thisFile
      END IF
      txt = getRichEditText(hEdit): IF LEN(txt) = 0 THEN EXIT SUB 
      fileNo = FREEFILE
      OPEN thisFile FOR BINARY ACCESS WRITE AS fileNo
      PUT #fileNo,, txt
      CLOSE fileNo
      fileChanged = 0
      SendMessage hEdit, %EM_SETMODIFY, fileChanged, 0
   ELSE
      saveAsFile
   END IF
END SUB

FUNCTION SaveDlgHookProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                         BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
  '-------------------------------------------------------------------------------------                       
  'this hook used during saveAs to match file extension with file type                      
  '-------------------------------------------------------------------------------------                       
  LOCAL hftEdit AS LONG, lRes AS LONG, zTxt AS ASCIIZ * %MAX_PATH, ofnPtr AS OFNOTIFY PTR
  SELECT CASE wMsg
     CASE %WM_NOTIFY
        ofnPtr = lParam
        SELECT CASE @ofnPtr.hdr.Code
           CASE %CDN_TYPECHANGE
              hftEdit  = GetDlgItem(GetParent(hWnd), %edt1) 'handle, File name text field
              GetWindowText hftEdit, zTxt, %MAX_PATH        'get name in text field 
              IF LEN(zTxt) THEN
                 lRes = INSTR(-1, zTxt, ".")                'look for prefix (file type part)
                 IF lRes THEN zTxt = LEFT$(zTxt, lRes - 1)  'if success, remove prefix
                 SELECT CASE @ofnPtr.@lpOFN.nFilterIndex    'compare selection against combo list
                    CASE 1    : zTxt = zTxt + ".txt"        'and add matching prefix
                    CASE 2    : zTxt = zTxt + ".rtf"
                 END SELECT
                 SetWindowText hftEdit, zTxt                'set corrected name to text field
              END IF
        END SELECT
  END SELECT
END FUNCTION

SUB saveAsFile()
   'api code used here to enable filter index
   LOCAL f, path, filter, sDefExt, sCaption, sExt, txt AS STRING
   LOCAL i, j, flags, index AS DWORD, ofn AS OPENFILENAME
   
   fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
   IF fileChanged = 0 AND LEN(thisFile) = 0 THEN EXIT SUB
   flags = %OFN_OVERWRITEPROMPT OR %OFN_LONGNAMES OR %OFN_EXPLORER OR %OFN_ENABLEHOOK 
   path = CURDIR$: f = LEFT$(thisFile, %MAX_PATH): sExt = "txt"
   filter = "Text Files (*.txt)|*.txt|" + _
            "Rich Text Files (*.rtf)|*.rtf|" + _
            "All Files (*.*)|*.*"
   REPLACE "|" WITH $NUL IN filter
   i = INSTR(-1, f, "."): IF i THEN sExt = TRIM$(LCASE$(MID$(f, i + 1)))
   f = RTRIM$(f, $NUL) + $NUL + SPACE$(%MAX_PATH - LEN(f))
   sDefExt = "txt": sCaption = "Save File"
   index = 3
   IF sExt = "txt" THEN index = 1
   IF sExt = "rtf" OR rtfFile THEN index = 2
   ofn.lStructSize      = SIZEOF(ofn)
   ofn.hWndOwner        = hDlg
   ofn.lpstrFilter      = STRPTR(filter)
   ofn.nFilterIndex     = index
   ofn.lpstrFile        = STRPTR(f)
   ofn.nMaxFile         = LEN(f)
   ofn.lpstrInitialDir  = STRPTR(path)
   ofn.lpfnHook         = CODEPTR(SaveDlgHookProc)
   ofn.Flags            = flags
   IF LEN(sCaption) THEN ofn.lpstrTitle = STRPTR(sCaption)
   IF LEN(sDefExt) THEN ofn.lpstrDefExt  = STRPTR(sDefExt)
   j = GetSaveFileName(ofn)
   i = INSTR(f, $NUL): IF i THEN f = LEFT$(f, i - 1) ELSE f = ""
   i = INSTR(-1, f, "."): sExt = MID$(f, i + 1)
   IF sExt = "rtf" THEN
      fileFmt = %SF_RTF: rtfEditor 1
      txt = getRichEditText(hEdit)
      putRichEditText hEdit, txt
   ELSE
      fileFmt = %SF_TEXT
      rtfFile = 0: rtfEditor 0
      txt = getRichEditText(hEdit)
      putRichEditText hEdit, txt
      SendMessage hEdit, %WM_SETFONT, hFont, 0          
      setColor textColor, 1: setBGColor scrnColor, 1
   END IF
   IF j THEN thisFile = f: saveTheFile: updateStatus 1 
   SendMessage(hEdit, %EM_SETMODIFY, fileChanged, 0)
END SUB

FUNCTION quitProgram() AS LONG
   LOCAL n AS LONG
   FUNCTION = -1
   fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
   IF fileChanged THEN
      n = MSGBOX("File has changed..." & $CRLF _
      & "do you want to save it?", %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
      IF n = %IDCANCEL THEN
         FUNCTION = 0
      ELSE
         IF n = %IDYES THEN saveTheFile
      END IF
   END IF
END FUNCTION

SUB updateStatus(OPT BYVAL fln AS LONG)
   LOCAL j, k, wi, ht, hdc, hFont1 AS LONG, s AS STRING
   IF fln THEN 
      DIALOG GET CLIENT hDlg TO wi, ht
      hdc = GetDC(hDlg): j = 7/8 * (wi - 150)
      hFont1 = SendMessage(hDlg, %WM_GETFONT, 0, 0)  'must select hWnd's font into DC,
      hFont1 = SelectObject(hdc, hFont1)             'otherwise System font is used
      IF LEN(thisFile) THEN s = fitLongFileName(thisFile, hdc, j)
      SelectObject hdc, hFont1                       'restore orig font to DC
      ReleaseDC hDlg, hdc                            'and release DC
      SendMessage hStatusbar, %SB_SETTEXT, 0, BYVAL STRPTR(s)
   END IF
   CONTROL SEND hDlg, %IDC_Text, %EM_GETSEL, VARPTR(j), 0
   CONTROL SEND hDlg, %IDC_Text, %EM_LINEFROMCHAR, j, 0 TO k
   s = "Row:" + STR$(k + 1)
   SendMessage hStatusbar, %SB_SETTEXT, 1, BYVAL STRPTR(s)
   '----------------------------------------------------------------
   CONTROL SEND hDlg, %IDC_Text, %EM_LINEINDEX, -1, 0 TO k
   s = "Col:" + STR$(j - k + 1)
   SendMessage hStatusbar, %SB_SETTEXT, 2, BYVAL STRPTR(s)
END SUB
 
FUNCTION fitLongFileName(s AS STRING, hdc AS LONG, w AS LONG) AS STRING
   'fit long file name in space of w pixels with balanced path name
   LOCAL i, j, k, m AS LONG, f AS STRING, pt AS POINTAPI
   GetTextExtentPoint32 hdc, BYVAL STRPTR(s), BYVAL LEN(s), pt
   IF pt.x <= w THEN FUNCTION = s: EXIT FUNCTION
   k = (PARSECOUNT(s, "\") + 1) \ 2
   'find middle part of path name and set it to "..."
   WHILE j < k: i = m: m = INSTR(i + 1, s, "\"): INCR j: WEND
   f = LEFT$(s, i) + "..." + MID$(s, m)
   k = (PARSECOUNT(s, "\") + 2) MOD 2
   DO WHILE pt.x > w AND TALLY(f, "\") > 2
      INCR k
      IF k MOD 2 THEN 
         REPLACE "...\" + PARSE$(f, "\", j + 1) WITH "..." IN f
      ELSE
         REPLACE PARSE$(f, "\", j - 1) + "\..." WITH "..." IN f: DECR j
      END IF
      GetTextExtentPoint32 hdc, BYVAL STRPTR(f), BYVAL LEN(f), pt
   LOOP
   FUNCTION = f
END FUNCTION
 
FUNCTION MakeFont(BYVAL fName AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL attr AS STRING) AS DWORD 
   '--------------------------------------------------------------------
   ' Create a desired font and return its handle.
   ' attr = "biu" for bold, italic, and underlined (any order)
   '--------------------------------------------------------------------
   LOCAL hDC AS DWORD, CharSet AS LONG, CyPixels AS LONG 
   LOCAL bold, italic, uLine AS LONG
   IF LEN(attr) THEN                             
      IF INSTR(LCASE$(attr), "b") THEN bold = %FW_BOLD
      IF INSTR(LCASE$(attr), "i") THEN italic = 1
      IF INSTR(LCASE$(attr), "u") THEN uLine = 1
   END IF
   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   enumFontFamilies hDC, BYVAL STRPTR(fName), CODEPTR(enumCharSet), BYVAL VARPTR(CharSet)
   ReleaseDC %HWND_DESKTOP, hDC
   PtSize = 0 - (ptSize * CyPixels) \ 72
   FUNCTION = CreateFont(ptSize, 0, 0, 0, bold, italic, uLine, _
             %FALSE, CharSet, %OUT_TT_PRECIS, _
             %CLIP_DEFAULT_PRECIS, %DEFAULT_QUALITY, _
             %FF_DONTCARE , BYCOPY fName)
END FUNCTION

FUNCTION enumCharSet (elf AS ENUMLOGFONT, ntm AS NEWTEXTMETRIC, _
                      BYVAL FontType AS LONG, CharSet AS LONG) AS LONG
   '--------------------------------------------------------------------
   ' Get type of character set - ansi, symbol, etc. A must for some fonts..
   ' Called from FUNCTION MakeFont.
   '--------------------------------------------------------------------
   CharSet = elf.elfLogFont.lfCharSet
END FUNCTION

SUB PageSetup()
   '--------------------------------------------------------------------
   ' Use COMDLG32's Page setup dialog for margin settings
   '--------------------------------------------------------------------
   LOCAL psd AS PAGESETUPDLGA
   psd.lStructSize   = SIZEOF(psd)
   psd.hwndOwner     = hDlg
   psd.flags         = %PSD_DISABLEPAPER OR %PSD_INTHOUSANDTHSOFINCHES OR _
                       %PSD_DISABLEPRINTER OR %PSD_MARGINS
                          
   psd.rtMargin.nLeft   = leftMargin   * 1000
   psd.rtMargin.nTop    = topMargin    * 1000
   psd.rtMargin.nRight  = rightMargin  * 1000
   psd.rtMargin.nBottom = bottomMargin * 1000

   '------------------------------------------------------------------
   ' Show the PageSetup dialog
   '------------------------------------------------------------------
   IF pDevMode THEN psd.hDevMode = pDevMode
   IF PageSetupDlg(psd) THEN
      leftMargin   = psd.rtMargin.nLeft   / 1000
      topMargin    = psd.rtMargin.nTop    / 1000
      rightMargin  = psd.rtMargin.nRight  / 1000
      bottomMargin = psd.rtMargin.nBottom / 1000
      pDevMode = GlobalLock(psd.hDevMode)
      prnOrientation = @pDevMode.dmOrientation
      GlobalUnlock pDevMode
   END IF
END SUB

'
' Return font name at caret's place
'
FUNCTION getFontName() AS STRING
  LOCAL cf AS CHARFORMAT
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_FACE
  CALL SendMessage(hEdit, %EM_GETCHARFORMAT, %SCF_SELECTION, VARPTR(cf))
  FUNCTION = cf.szFaceName
END FUNCTION

'
' Return font size at caret's place
'
FUNCTION getFontSize() AS LONG
  LOCAL cf AS CHARFORMAT
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_SIZE
  CALL SendMessage(hEdit, %EM_GETCHARFORMAT, %SCF_SELECTION, VARPTR(cf))
  FUNCTION = cf.yHeight / 20
END FUNCTION
 
'--------------------------------------------------------------------------------------------------
'  Find and replace routines
'--------------------------------------------------------------------------------------------------
FUNCTION myFind(hText AS LONG, findTxt AS STRING, whole AS LONG, ncase AS LONG, ndir AS LONG) AS LONG 
   'this function finds and returns the next position of the search string
   'hText   = handle of rich edit control holding the text to be searched
   'findTxt = string to be searched for
   'whole, ncase, ndir specifies search state to be used 
   '-------------------------------------------------------------------------------------
   LOCAL j, k, n, nPos AS LONG, ft AS FINDTEXTEX
   SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)
   ft.lpstrText = STRPTR(findTxt)
   IF ndir > 0 THEN
      ft.chrg.cpmin = j 
      IF k > j THEN ft.chrg.cpmin = j + LEN(findTxt)
      ft.chrg.cpmax = -1
      n = %FR_DOWN
   ELSE
      ft.chrg.cpmin = j - 1
      ft.chrg.cpmax = 0
   END IF
   IF whole THEN n = n OR %FR_WHOLEWORD
   IF ncase THEN n = n OR %FR_MATCHCASE
   nPos = SendMessage(hEdit, %EM_FINDTEXTEX, n, VARPTR(ft))
   FUNCTION = nPos
END FUNCTION 

FUNCTION myFindReplace(hText AS LONG, OPT BYVAL nOpt AS LONG) AS LONG
   'Find and replace rich edit routines by Charles Dietz 
   'hText = handle of rich edit control
   'nOpt  =  0  find dialog
   '      =  1  replace dialog
   '      =  3  find next
   '      = -3  find prev
   'find state remembered when [keep dialog open] checkbox is cleared
   'set start and finish selection variables on return
   'return true if text is changed by replace
   'hold parameters to be passed to callback in xParms() array
   'xParms(4): j, k, nOpt, whole, case
   '-------------------------------------------------------------------
   LOCAL hFindRepl, j, k, n, nPos AS LONG
   LOCAL ti, findTxt AS STRING, zTxt AS ASCIIZ * 1024
   STATIC whole, ncase, showDlg AS LONG
   STATIC parmsPtr AS LONG PTR
   DIM parms(4) AS LONG: parmsPtr = VARPTR(parms(0))
   IF showDlg = 0 THEN whole = 1: ncase = 0 
   IF nOpt = 3 THEN 'find next
      SendMessage hText, %EM_GETSELTEXT, 0, VARPTR(zTxt)
      findTxt = zTxt
      nPos = myFind(hText, findTxt, whole, ncase, 1)
      IF nPos = -1 THEN 'position cursor at start of text and search again
         SendMessage hText, %EM_SETSEL, 0, 0: BEEP
         nPos = myFind(hText, findTxt, whole, ncase, 1)
      END IF
      SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)
      EXIT FUNCTION
   ELSEIF nOpt = -3 THEN 'find prev
      SendMessage hText, %EM_GETSELTEXT, 0, VARPTR(zTxt)
      findTxt = zTxt
      nPos = myFind(hText, findTxt, whole, ncase, -1)
      IF nPos = -1 THEN 'position cursor at end of text and search again
         n = GetWindowTextLength(hText)
         SendMessage hText, %EM_SETSEL, n, n: BEEP
         nPos = myFind(hText, findTxt, whole, ncase, -1)
      END IF
      SendMessage hText, %EM_SETSEL, nPos, nPos + LEN(findTxt)
      EXIT FUNCTION
   ELSEIF nOpt THEN 'show replace dialog
      n = 20: ti = "Replace"
   ELSE 'show find dialog
      ti = "Find"
   END IF
   showDlg = 1: parms(2) = nOpt
   DIALOG NEW hText, ti, , , 250, 100 + n, %WS_SYSMENU TO hFindRepl
   CONTROL ADD LABEL, hFindRepl, -1, "&What:", 10, 10, 25, 10
   CONTROL ADD TEXTBOX, hFindRepl, 101, "", 40, 10, 140, 12
   IF n THEN
      CONTROL ADD LABEL, hFindRepl, -1, "&With:", 10, 30, 25, 10
      CONTROL ADD TEXTBOX, hFindRepl, 201, "", 40, 30, 140, 12
   END IF
   CONTROL ADD CHECKBOX, hFindRepl, 102, "Match &whole word only", 10, 35 + n, 100, 10
   CONTROL ADD CHECKBOX, hFindRepl, 103, "Match &case", 10, 50 + n, 100, 10
   IF n = 0 THEN
      CONTROL ADD FRAME, hFindRepl, -1, "Direction", 120, 30 + n, 60, 40
      CONTROL ADD OPTION, hFindRepl, 104, "&Up", 125, 40 + n, 40, 10
      CONTROL ADD OPTION, hFindRepl, 105, "&Down", 125, 55 + n, 40, 10
      CONTROL ADD CHECKBOX, hFindRepl, 107, "Keep dialog open", 10, 65, 100, 10
   END IF
   CONTROL SET CHECK hFindRepl, 102, 1
   CONTROL SET OPTION hFindRepl, 105, 104, 105
   CONTROL ADD BUTTON, hFindRepl, %IDOK, "&Find next", 190, 5, 50, 20
   IF n THEN
      CONTROL ADD BUTTON, hFindRepl, 202, "&Replace", 190, 27, 50, 20
      CONTROL ADD BUTTON, hFindRepl, 203, "Replace &All", 190, 49, 50, 20
      n = 41
   END IF
   CONTROL ADD BUTTON, hFindRepl, %IDCANCEL, "Cancel", 190, 30 + n, 50, 20
   DIALOG SET USER hFindRepl, 1, parmsPtr
   DIALOG SET USER hFindRepl, 2, hText
   DIALOG SHOW MODAL hFindRepl CALL findReplaceProc
   j = @parmsPtr[0]: k = @parmsPtr[1]
   nOpt = @parmsPtr[2]: IF ABS(nOpt) THEN j = -1
   SendMessage hText, %EM_SETSEL, j, k
   whole = @parmsPtr[3]: ncase = @parmsPtr[4]
   IF nOpt < 0 THEN FUNCTION = 1
END FUNCTION
 
CALLBACK FUNCTION findReplaceProc()
   LOCAL whole, ncase, ndir, keep AS LONG
   LOCAL findTxt, replaceTxt AS STRING
   LOCAL zTxt AS ASCIIZ * 1024
   STATIC hText, nOpt, cycle, j, k AS LONG 
   STATIC parmsPtr AS LONG PTR
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIALOG GET USER CBHNDL, 1 TO parmsPtr
         DIALOG GET USER CBHNDL, 2 TO hText
         nOpt = @parmsPtr[2]: cycle = 0
         SendMessage hText, %EM_GETSEL, VARPTR(j), VARPTR(k)
         SendMessage hText, %EM_GETSELTEXT, 0, VARPTR(zTxt)
         CONTROL SET TEXT CBHNDL, 101, zTxt   'initial text to search for
         CONTROL SET CHECK CBHNDL, 107, findDlg
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN 'find text
            CONTROL GET TEXT CBHNDL, 101 TO findTxt
            CONTROL GET CHECK CBHNDL, 102 TO whole                                         
            CONTROL GET CHECK CBHNDL, 103 TO ncase
            CONTROL GET CHECK CBHNDL, 107 TO keep
            CONTROL GET CHECK CBHNDL, 105 TO ndir
            IF ndir = 0 THEN ndir = -1
            IF nOpt = 1 THEN ndir = 1 'replace dlg
            j = myFind(hText, findTxt, whole, ncase, ndir)
            IF j > -1 THEN  'found text
               cycle = 0: k = j + LEN(findTxt)
               SendMessage hText, %EM_SETSEL, j, k
               @parmsPtr[0] = j: @parmsPtr[1] = k
               @parmsPtr[3] = whole: @parmsPtr[4] = ncase
               IF nOpt OR keep THEN whole = 1: ncase = 0 ELSE DIALOG END CBHNDL, parmsPtr
            ELSEIF cycle = 0 THEN
               INCR cycle
               j = 0: IF ndir < 0 THEN j = -1
               SendMessage hText, %EM_SETSEL, j, j
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0
            ELSE
               MSGBOX "None found", , "Find Text"
               cycle = 0: DIALOG END CBHNDL, parmsPtr   
            END IF
         ELSEIF CBCTL = 202 THEN 'replace found text
            CONTROL GET TEXT CBHNDL, 201 TO replaceTxt
            SendMessage hText, %EM_REPLACESEL, 1, STRPTR(replaceTxt)
            DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0
         ELSEIF CBCTL = 203 THEN 'replace all
            CONTROL GET CHECK CBHNDL, 102 TO whole                                         
            CONTROL GET CHECK CBHNDL, 103 TO ncase
            CONTROL GET TEXT CBHNDL, 101 TO findTxt
            CONTROL GET TEXT CBHNDL, 201 TO replaceTxt
            SendMessage hText, %EM_SETSEL, 0, 0
            DO             
               j = myFind(hText, findTxt, whole, ncase, 1)
               IF j = -1 THEN EXIT DO
               SendMessage hText, %EM_SETSEL, j, j + LEN(findTxt)
               SendMessage hText, %EM_REPLACESEL, 1, STRPTR(replaceTxt)
            LOOP WHILE j
            @parmsPtr[2] = -1: DIALOG END CBHNDL, parmsPtr
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL, parmsPtr
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN DIALOG END CBHNDL, parmsPtr
   END SELECT
END FUNCTION

'
' RTF format routines
'
FUNCTION enumFontFamProc(lf AS LOGFONT, tm AS TEXTMETRIC, _
                         BYVAL FontType AS LONG, lRet AS LONG) AS LONG
   IF lRet = 0 THEN
      gLF = lf
   ELSE
      IF (FontType AND %TRUETYPE_FONTTYPE) THEN
         COMBOBOX ADD hCurrentDlg, %IDC_FontNames, lf.lfFaceName
      END IF
   END IF
   FUNCTION = lRet  'lRet decides: 0 stops enumeration, <> 0 makes sure it continues
END FUNCTION

SUB enumFontSizes(BYVAL sFontName AS STRING, BYVAL hWnd AS DWORD)
   LOCAL hDC AS DWORD
   SendMessage hWnd, %LB_RESETCONTENT, 0, 0
   hDC = GetDC(%HWND_DESKTOP)
   enumFonts hDC, BYCOPY sFontName, CODEPTR(fontSizeProc), BYVAL VARPTR(hWnd)
   ReleaseDC %HWND_DESKTOP, hDC
END SUB

FUNCTION fontSizeProc(lf AS LOGFONT, tm AS TEXTMETRIC, _
                      BYVAL FontType AS LONG, hWnd AS DWORD) AS LONG
   LOCAL hDC AS DWORD, LogPixelY AS LONG, x AS LONG, zText AS ASCIIZ * 5
   IF FontType = %RASTER_FONTTYPE THEN  'Windows enumerates available sizes
      hDC = GetDC(%HWND_DESKTOP)
      LogPixelY = GetDeviceCaps(hDC, %LOGPIXELSY)
      ReleaseDC 0, hDC
      x = MulDiv(tm.tmHeight - tm.tmInternalLeading, 72, LogPixelY)
      GOSUB AddPointSize
   ELSE 'TrueType - we shall add our own sizes 
      x =  6 : GOSUB AddPointSize
      x =  7 : GOSUB AddPointSize
      x =  8 : GOSUB AddPointSize  
      x =  9 : GOSUB AddPointSize
      x = 10 : GOSUB AddPointSize
      x = 11 : GOSUB AddPointSize
      x = 12 : GOSUB AddPointSize
      x = 14 : GOSUB AddPointSize
      x = 16 : GOSUB AddPointSize
      x = 18 : GOSUB AddPointSize
      x = 20 : GOSUB AddPointSize
      x = 24 : GOSUB AddPointSize
      x = 32 : GOSUB AddPointSize
   END IF
   FUNCTION = 1
EXIT FUNCTION
AddPointSize:
  'Note: some TrueType fonts gets enumerated many times and some only once,
  '      so we need to use %LB_FINDSTRINGEXACT to avoid duplicate sizes.
  zText = USING$("##", x)
  IF SendMessage(hWnd, %CB_FINDSTRINGEXACT, -1, VARPTR(zText)) = %CB_ERR THEN
     SendMessage hWnd, %CB_ADDSTRING, 0, VARPTR(zText)
  END IF
RETURN
END FUNCTION

FUNCTION getEffect() AS LONG
   LOCAL cf AS CHARFORMAT
   cf.cbsize = LEN(cf)
   cf.dwMask = %CFM_BOLD OR %CFM_ITALIC OR %CFM_UNDERLINE
   SendMessage hEdit, %EM_GETCHARFORMAT, %SCF_SELECTION, VARPTR(cf)
   FUNCTION = cf.dwEffects
END FUNCTION

FUNCTION getColor() AS LONG
  LOCAL cf AS CHARFORMAT        
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_COLOR
  SendMessage hEdit, %EM_GETCHARFORMAT, %SCF_SELECTION, VARPTR(cf)
  FUNCTION = cf.crTextColor
END FUNCTION

FUNCTION getBGColor() AS LONG
  LOCAL cf AS CHARFORMAT2        
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_BACKCOLOR
  SendMessage hEdit, %EM_GETCHARFORMAT, %SCF_SELECTION, VARPTR(cf)
  FUNCTION = cf.crBackColor
END FUNCTION

SUB setEffect(BYVAL fontEffect AS LONG)
   LOCAL cf AS CHARFORMAT
   cf.cbsize    = LEN(cf)
   cf.dwMask    = %CFM_BOLD OR %CFM_ITALIC OR %CFM_UNDERLINE 'OR %CFM_STRIKEOUT
   cf.dwEffects = fontEffect
   SendMessage hEdit, %EM_SETCHARFORMAT, %SCF_SELECTION, VARPTR(cf)
   updateRTFControls
END SUB 

SUB setColor(BYVAL textColor AS LONG, OPT BYVAL kAll AS LONG)
  LOCAL cf AS CHARFORMAT, n AS LONG
  IF kAll THEN n = %SCF_ALL ELSE n = %SCF_WORD OR %SCF_SELECTION
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_COLOR
  cf.crTextColor = textColor
  SendMessage hEdit, %EM_SETCHARFORMAT, n, VARPTR(cf)
  updateRTFControls
END SUB 

SUB setBGColor(BYVAL backColor AS LONG, OPT BYVAL kAll AS LONG)
  LOCAL cf AS CHARFORMAT2, n AS LONG
  IF kAll THEN n = %SCF_ALL ELSE n = %SCF_WORD OR %SCF_SELECTION
  cf.cbsize = LEN(cf)
  cf.dwMask = %CFM_BACKCOLOR
  cf.crBackColor = backColor
  SendMessage hEdit, %EM_SETCHARFORMAT, n, VARPTR(cf)
  updateRTFControls
END SUB 

SUB setFontName(BYVAL fName AS STRING)
   'set font name at caret's place or for selection
   LOCAL hDC AS LONG, lRet AS LONG, cf AS CHARFORMAT
   cf.cbsize = LEN(cf)
   cf.dwMask = %CFM_FACE OR %CFM_CHARSET
   hDC = GetDC(%HWND_DESKTOP) 'important: get proper bCharSet and bPitchAndFamily via enumeration
   EnumFontFamilies hDC, BYVAL STRPTR(fName), CODEPTR(EnumFontFamProc), BYVAL VARPTR(lRet)
   ReleaseDC %HWND_DESKTOP, hDC
   cf.szFaceName      = gLF.lfFaceName
   cf.bCharSet        = gLF.lfCharSet
   cf.bPitchAndFamily = gLF.lfPitchAndFamily
   SendMessage hEdit, %EM_SETCHARFORMAT, %SCF_WORD OR %SCF_SELECTION, VARPTR(cf)
   updateRTFControls
END SUB

SUB setFontSize(BYVAL fSize AS LONG)
   'set font size at caret's position or selection
   LOCAL cf AS CHARFORMAT
   cf.cbsize = LEN(cf)
   cf.dwMask = %CFM_SIZE
   cf.yHeight = fSize * 20
   SendMessage hEdit, %EM_SETCHARFORMAT, %SCF_WORD OR %SCF_SELECTION, VARPTR(cf)
   updateRTFControls
END SUB

SUB setIndent(leftIndent AS LONG, rightIndent AS LONG, firstLine AS LONG)
   'indents are measured in twips (1/1440 inch)
   LOCAL pf AS PARAFORMAT
   pf.cbsize = LEN(pf)
   pf.dwMask = %PFM_STARTINDENT OR %PFM_RIGHTINDENT
   pf.dxStartIndent = leftIndent
   pf.dxRightIndent = rightIndent
   SendMessage hEdit, %EM_SETPARAFORMAT, 0, VARPTR(pf)
   IF firstLine THEN
      pf.dwMask = %PFM_OFFSETINDENT OR %PFM_OFFSET	
      pf.dxStartIndent = firstLine
      pf.dxOffset = -firstLine
      SendMessage hEdit, %EM_SETPARAFORMAT, 0, VARPTR(pf)  
   END IF
END SUB

SUB setJustify(align AS LONG)
   LOCAL pf AS PARAFORMAT
   pf.cbsize = LEN(pf)
   pf.dwMask = %PFM_ALIGNMENT
   pf.wAlignment = align	
   SendMessage hEdit, %EM_SETPARAFORMAT, 0, VARPTR(pf)
END SUB

SUB setBullets
   LOCAL pf AS PARAFORMAT
   pf.cbsize = LEN(pf)
   pf.dwMask = %PFM_NUMBERING
   pf.wNumbering = %PFN_BULLET	
   SendMessage hEdit, %EM_SETPARAFORMAT, 0, VARPTR(pf)
END SUB

SUB updateRTFControls
   LOCAL lRet, fontColor, BGColor AS LONG, txt AS STRING
   txt = getFontName
   SendMessage GetDlgItem(hDlg, %IDC_FontNames), %CB_SELECTSTRING, -1, BYVAL STRPTR(txt)
   txt = FORMAT$(getFontSize)
   lRet = SendMessage(GetDlgItem(hDlg, %IDC_FontSizes), %CB_SELECTSTRING, -1, BYVAL STRPTR(txt))
   IF lRet = -1 THEN CONTROL SET TEXT hDlg, %IDC_FontSizes, txt
   lRet = GetEffect
   CONTROL SEND hDlg, %IDC_Bold, %BM_SETCHECK, _
               IIF&((lRet AND %CFE_BOLD), %BST_CHECKED, %BST_UNCHECKED), 0
   CONTROL SEND hDlg, %IDC_Italic, %BM_SETCHECK, _
               IIF&((lRet AND %CFE_ITALIC), %BST_CHECKED, %BST_UNCHECKED), 0
   CONTROL SEND hDlg, %IDC_Uline, %BM_SETCHECK, _
               IIF&((lRet AND %CFE_UNDERLINE), %BST_CHECKED, %BST_UNCHECKED), 0
   fontColor = getColor: BGColor = getBGColor
   IF BGColor = 0 THEN BGColor = scrnColor
   CONTROL SET COLOR hDlg, %IDC_ColorView, fontColor, BGColor
   InvalidateRect hDlg, BYVAL %NULL, 0
   SetFocus hEdit
END SUB

SUB fontDlg()
   DIALOG NEW hDlg, "Character Font", 35, 54, 240, 150, %WS_SYSMENU TO hFontDlg
   CONTROL ADD COMBOBOX, hFontDlg, %IDC_FontNames, , 15, 10, 140, 75, %WS_CHILD _
      OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DROPDOWNLIST OR %CBS_SORT
   CONTROL ADD COMBOBOX, hFontDlg, %IDC_FontSizes, , 165, 10, 40, 75, %WS_CHILD _
      OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DROPDOWNLIST OR %CBS_SORT
   CONTROL ADD CHECKBOX, hFontDlg, %IDC_Bold, "&Bold", 30, 40, 55, 10
   CONTROL ADD CHECKBOX, hFontDlg, %IDC_Italic, "&Italic", 90, 40, 55, 10
   CONTROL ADD CHECKBOX, hFontDlg, %IDC_ULine, "&UnderLine", 150, 40, 55, 10
   CONTROL ADD BUTTON, hFontDlg, %IDC_Color, "&Text Color", 30, 70, 50, 15
   CONTROL ADD LABEL, hFontDlg, %IDC_ColorView, "", 85, 70, 15, 15
   CONTROL ADD BUTTON, hFontDlg, %IDC_BGColor, "BG &Color", 30, 90, 50, 15
   CONTROL ADD LABEL, hFontDlg, %IDC_BGColorView, "", 85, 90, 15, 15
   CONTROL ADD LINE, hFontDlg, -1, "", 85, 70, 15, 15, %SS_BLACKFRAME
   CONTROL ADD BUTTON, hFontDlg, %IDOK, "Ok", 160, 65, 45, 20
   CONTROL ADD BUTTON, hFontDlg, %IDCANCEL, "Cancel", 160, 90, 45, 20
   DIALOG SHOW MODAL hFontDlg, CALL fontDlgProc
END SUB

CALLBACK FUNCTION fontDlgProc()
   LOCAL lRet, hdc, hWnd, hWnd1, n, n1, n2, n3, fontSize AS LONG
   LOCAL s AS STRING, cc AS CHOOSECOLORAPI, sz AS ASCIIZ*64
   STATIC fontColor, BGColor AS LONG
   SELECT CASE AS LONG CBMSG
      CASE %WM_INITDIALOG 
         fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
         hCurrentDlg = CBHNDL
         lRet = 1 'enumerate all fonts and fill font name combobox
         hDC = GetDC(%HWND_DESKTOP)
         enumFontFamilies hDC, BYVAL %NULL, CODEPTR(enumFontFamProc), BYVAL VARPTR(lRet)
         ReleaseDC %HWND_DESKTOP, hDC
         s = getFontName
         CONTROL SEND CBHNDL, %IDC_FontNames, %CB_SELECTSTRING, -1, STRPTR(s)
         CONTROL HANDLE CBHNDL, %IDC_FontSizes TO hWnd
         enumFontSizes s, hWnd 'enumerate font sizes for current font
         sz = USING$("##", getFontSize)
         CONTROL SEND CBHNDL, %IDC_FontSizes, %CB_SELECTSTRING, -1, VARPTR(sz)
         CONTROL SET CHECK CBHNDL, %IDC_Bold, (getEffect AND %CFE_BOLD)
         CONTROL SET CHECK CBHNDL, %IDC_Italic, (getEffect AND %CFE_ITALIC)
         CONTROL SET CHECK CBHNDL, %IDC_ULine, (getEffect AND %CFE_UNDERLINE)
         IF fileFmt = %SF_TEXT THEN
            fontColor = textColor: BGColor = scrnColor
         ELSE
            fontColor = getColor: BGColor = getBGColor
            IF BGColor = 0 THEN BGColor = scrnColor
         END IF
         CONTROL SET COLOR CBHNDL, %IDC_ColorView, fontColor, fontColor
         CONTROL SET COLOR CBHNDL, %IDC_BGColorView, BGColor, BGColor
      CASE %WM_COMMAND
         SELECT CASE AS LONG CBCTL
            CASE %IDC_Color, %IDC_BGColor
               IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                  DIM lCustomColor(15) AS LOCAL LONG 'array
                  cc.lStructSize  = LEN(CHOOSECOLORAPI)
                  cc.hwndOwner    = hDlg  'Handle of owner window
                  cc.lpCustColors = VARPTR(lCustomColor(0))
                  cc.flags        = %CC_RGBINIT
                  cc.rgbResult    = getColor
                  IF CBCTL = %IDC_BGColor THEN cc.rgbResult = BGColor
                  lRet = ChooseColor(cc)
                  IF CBCTL = %IDC_Color THEN
                     fontColor = cc.rgbResult
                     CONTROL SET COLOR CBHNDL, %IDC_ColorView, fontColor, fontColor
                  ELSE  
                     BGColor = cc.rgbResult
                     CONTROL SET COLOR CBHNDL, %IDC_BGColorView, BGColor, BGColor
                  END IF
                  InvalidateRect CBHNDL, BYVAL %NULL, 0 
               END IF
               CONTROL SET FOCUS CBHNDL, %IDOK
            CASE %IDC_FontNames
               IF CBCTLMSG = %CBN_SELCHANGE THEN
                  CONTROL HANDLE CBHNDL, %IDC_FontNames TO hWnd
                  CONTROL HANDLE CBHNDL, %IDC_FontSizes TO hWnd1
                  SendMessage hWnd1, %CB_RESETCONTENT, 0, 0
                  n = SendMessage(hWnd, %CB_GETCURSEL, 0, 0)
                  SendMessage hWnd, %CB_GETLBTEXT, n, VARPTR(sz): s = sz
                  enumFontSizes s, hWnd1 'enumerate font sizes for current font
                  SendMessage hWnd1, %CB_SETCURSEL, 0, 0
               END IF   
            CASE %IDOK
               COMBOBOX GET TEXT CBHNDL, %IDC_FontNames TO fontName
               COMBOBOX GET TEXT CBHNDL, %IDC_FontSizes TO s: fontSize = VAL(s)
               CONTROL GET CHECK CBHNDL, %IDC_Bold TO n1
               CONTROL GET CHECK CBHNDL, %IDC_Italic TO n2
               CONTROL GET CHECK CBHNDL, %IDC_ULine TO n3
               DIALOG END CBHNDL
               SendMessage hEdit, %WM_SETREDRAW, 0, 0
               IF fileFmt = %SF_TEXT THEN SendMessage hEdit, %EM_SETSEL, 0, -1
               IF n1 THEN 
                  setEffect BYVAL (getEffect OR %CFE_BOLD)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_BOLD)
               END IF
               IF n2 THEN 
                  setEffect BYVAL (getEffect OR %CFE_ITALIC)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_ITALIC)
               END IF
               IF n3 THEN
                  setEffect BYVAL (getEffect OR %CFE_UNDERLINE)
               ELSE
                  setEffect BYVAL (getEffect AND NOT %CFE_UNDERLINE)
               END IF
               IF rtfFile THEN
                  setFontName fontName: setFontSize fontSize 
               ELSE
                  DeleteObject hFont
                  s = STRING$(n1, "b") + STRING$(n2, "i") + STRING$(n3, "u")
                  hFont = MakeFont(fontName, fontSize, s)
                  SendMessage hEdit, %EM_SETBKGNDCOLOR, 0, BGColor
               END IF
               setFontName fontName: setFontSize fontSize
               scrnColor = BGColor: textColor = fontColor
               setColor fontColor: setBGColor BGColor
               SendMessage hEdit, %EM_SETSEL, -1, 0
               SendMessage hEdit, %WM_SETREDRAW, 1, 0
               SendMessage hEdit, %EM_SETMODIFY, 0, 0 
               updateRTFControls
               InvalidateRect hEdit, BYVAL %NULL, 0
            CASE %IDCANCEL
               IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                  DIALOG END CBHNDL, 0
               END IF
         END SELECT
   END SELECT
END FUNCTION

SUB paragraphDlg()
   LOCAL hPara AS LONG
   DIALOG NEW PIXELS, 0, "Paragraph", , , 250, 200, %WS_SYSMENU TO hPara
   CONTROL ADD FRAME, hPara, -1, "Indent", 5, 5, 145, 115
   CONTROL ADD LABEL, hPara, -1, "Left:", 15, 25, 50, 12
   CONTROL ADD TEXTBOX, hPara, %IDC_LeftIndent, "", 65, 25, 60, 15
   CONTROL ADD LABEL, hPara, -1, "Right:", 15, 55, 50, 12
   CONTROL ADD TEXTBOX, hPara, %IDC_RightIndent, "", 65, 55, 60, 15
   CONTROL ADD LABEL, hPara, -1, "First line:", 15, 85, 50, 12
   CONTROL ADD TEXTBOX, hPara, %IDC_FirstLine, "", 65, 85, 60, 15
   CONTROL ADD LABEL, hPara, -1, "Justify:", 15, 140, 50, 12
   CONTROL ADD COMBOBOX, hPara, %IDC_Align, , 65, 140, 70, 90, %WS_TABSTOP OR %CBS_DROPDOWN
   CONTROL ADD BUTTON, hPara, %IDOK, "Ok", 170, 15, 60, 25
   CONTROL ADD BUTTON, hPara, %IDCANCEL, "Cancel", 170, 45, 60, 25
   DIALOG SHOW MODAL hPara CALL paragraphProc
END SUB

CALLBACK FUNCTION paragraphProc()
   LOCAL s AS STRING, n AS LONG
   SELECT CASE CBMSG 
      CASE %WM_INITDIALOG
         COMBOBOX ADD CBHNDL, %IDC_Align, "Left"
         COMBOBOX ADD CBHNDL, %IDC_Align, "Right"
         COMBOBOX ADD CBHNDL, %IDC_Align, "Center"
         COMBOBOX ADD CBHNDL, %IDC_Align, "Full"
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            CONTROL GET TEXT CBHNDL, %IDC_LeftIndent TO s
            leftIndent = VAL(s) * 1440
            CONTROL GET TEXT CBHNDL, %IDC_RightIndent TO s
            rightIndent = VAL(s) * 1440
            CONTROL GET TEXT CBHNDL, %IDC_FirstLine TO s
            firstLine = VAL(s) * 1440
            setIndent leftIndent, rightIndent, firstLine
            CONTROL GET TEXT CBHNDL, %IDC_Align TO s
            IF LEN(s) THEN
               SELECT CASE s
                  CASE "Left": n = %PFA_LEFT
                  CASE "Right": n = %PFA_RIGHT
                  CASE "Center": n = %PFA_CENTER
               END SELECT
               setJustify n
            END IF   
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB Clipboard_SetText(BYVAL txt AS STRING)
   'copy txt to clipboard
   '-------------------------------------------------------------
   LOCAL lpMem AS ASCIIZ PTR
   LOCAL hMem  AS DWORD
   ' Allocate global memory block
   hMem  = GlobalAlloc(%GHND, LEN(txt) + 1)
   ' lock it and get pointer to memory location
   lpMem = GlobalLock(hMem)
   ' copy text into memory object
   @lpMem = txt
   ' unlock the memory object
   GlobalUnlock hMem
   ' add text to the clipboard
   OpenClipboard 0
   EmptyClipboard
   SetClipboardData %CF_TEXT, hMem
   CloseClipboard
END SUB

FUNCTION Clipboard_GetText() AS STRING
   'get txt from clipboard
   '-------------------------------------------------------------
   LOCAL hMem  AS DWORD
   LOCAL lpMem AS ASCIIZ PTR
   ' open the clipboard
   IF ISFALSE(OpenClipboard(%NULL)) THEN EXIT FUNCTION
   ' Get memory object of clipboard text
   hMem = GetClipboardData(%CF_TEXT)
   ' lock it and get a pointer
   lpMem = GlobalLock(hMem)
   ' assign the data to our function return value
   FUNCTION = @lpMem
   ' release the memory object
   GlobalUnlock hMem
   ' close the clipboard
   CloseClipboard
END FUNCTION   

'-----------------------------------------------------------------------
'strip extraneous ascii codes
'-----------------------------------------------------------------------
SUB stripCodes()
   LOCAL txt AS STRING, i, j, k AS LONG
   fileFmt = %SF_TEXT
   rtfFile = 0: rtfEditor 0
   txt = getRichEditText(hEdit)
   FOR i = 1 TO LEN(txt)
      k = ASC(txt, i)
      IF k = 9 OR k = 13 OR (k >= 32 AND k < 127) THEN
         INCR j: MID$(txt, j, 1) = MID$(txt, i, 1)
      END IF
   NEXT i
   txt = LEFT$(txt, j)
   putRichEditText hEdit, txt
   SendMessage hEdit, %WM_SETFONT, hFont, 0          
   setColor textColor, 1: setBGColor scrnColor, 1
   updateStatus 1
END SUB

'-----------------------------------------------------------------------
'Print and Print preview routines
'-----------------------------------------------------------------------
SUB printPreview()
   LOCAL nStyle AS LONG
   IF SendMessage(hEdit, %WM_GETTEXTLENGTH, 0, 0) = 0 THEN EXIT SUB
   DIALOG NEW PIXELS, 0, "Print Preview", , , 500, 500, %WS_SYSMENU TO hPreviewDlg
   CONTROL ADD BUTTON, hPreviewDlg, %IDC_Fwd, "Next", 10, 5, 40, 20
   CONTROL ADD BUTTON, hPreviewDlg, %IDC_Bwd, "Prev", 50, 5, 40, 20
   CONTROL ADD LABEL, hPreviewDlg, -1, "Page No:", 100, 7, 48, 15             
   CONTROL ADD TEXTBOX, hPreviewDlg, %IDC_PageNo, " 0", 150, 5, 25, 20, %ES_NUMBER
   CONTROL ADD LABEL, hPreviewDlg, %IDC_NumPages, "", 180, 7, 70, 15
   CONTROL ADD BUTTON, hPreviewDlg, %IDC_Zoom, "&Zoom", 250, 5, 50, 20                
   CONTROL ADD BUTTON, hPreviewDlg, %IDC_Print, "&Print", 300, 5, 50, 20 
   CONTROL ADD COMBOBOX, hPreviewDlg, %IDC_Printers, , 350, 5, 150, 100, %CBS_DROPDOWN
   CONTROL ADD SCROLLBAR, hPreviewDlg, %IDC_VScroll, "", 500, 30, 18, 540
   CONTROL ADD SCROLLBAR, hPreviewDlg, %IDC_HScroll, "", 0, 570, 500, 20
   DIALOG SHOW MODAL hPreviewDlg CALL printPreviewProc
END SUB

TYPE MyBITMAPINFO
  bmiHeader AS BITMAPINFOHEADER
  bmiColors(0 TO 1) AS RGBQUAD
END TYPE

CALLBACK FUNCTION printPreviewProc()
   LOCAL xppi, yppi, i, j, result AS LONG 
   LOCAL ps AS PAINTSTRUCT, s AS STRING
   LOCAL cr AS CHARRANGE, txt AS STRING
   STATIC bm AS BITMAP                 'bitmap of rich edit page
   STATIC bmBits AS STRING             'string serving as memory for DIB bits
   STATIC bmSize AS LONG               'space needed by bitmap bits
   STATIC bmInfo AS myBITMAPINFO       'structure defining properties of a DIB
   STATIC bitsPtr AS STRING PTR        'pointer to string memory
   STATIC nWi, nHt, nx, ny, xp, yp, x, y AS DWORD
   STATIC nPage, lastPage, hVScroll, hHScroll AS LONG
   STATIC hdc, memdc, hBmp AS DWORD, zoom AS SINGLE
   STATIC si, ssi AS SCROLLINFO, r AS rect
   STATIC savText AS STRING, sz AS ASCIIZ * 128, start, finish AS LONG
   SELECT CASE CBMSG 
      CASE %WM_INITDIALOG
         'enumerate printers --------------------------------------------- 
         IF PRINTERCOUNT = 0 THEN 
            s = "No connected Windows printer  "
            MSGBOX s, %MB_ICONERROR, "Initialize Print Preview"
            DIALOG END CBHNDL: EXIT FUNCTION
         END IF
         IF LEN(printerName) = 0 THEN
            GetProfileString "WINDOWS", "DEVICE", "", sz, 127
            printerName = TRIM$(PARSE$(sz, ",", 1))
         END IF
         COMBOBOX RESET CBHNDL, %IDC_Printers
         FOR i = 1 TO PRINTERCOUNT
            s = TRIM$(PRINTER$(NAME, i))
            IF s = printerName THEN j = i
            COMBOBOX ADD CBHNDL, %IDC_Printers, s
         NEXT i
         COMBOBOX SELECT CBHNDL, %IDC_Printers, j
 
         'setup selected text --------------------------------------------
         start = 0: finish = 0
         'DIALOG SHOW STATE hDlg, %SW_HIDE
         SendMessage hEdit, %EM_EXGETSEL, 0, VARPTR(cr)
         start = cr.cpMin + 1: finish = cr.cpMax + 1
         txt = SPACE$(finish - start + 1)
         IF finish > start THEN
            DIALOG SHOW STATE hDlg, %SW_HIDE
            fileChanged = SendMessage(hEdit, %EM_GETMODIFY, 0, 0)
            savText = getRichEditText(hEdit)
            SendMessage hEdit, %EM_GETSELTEXT, 0, STRPTR(txt)
            putRichEditText hEdit, txt
         END IF

         '--------------------------------------------------------------------------
         'prepare target window size proportional to paper print zone
         'get page dimensions in Twips (1440 twips per inch)
         'prnWi, prnHt = dimensions of what printer can print (excludes dead zones)
         'pageWi, pageHt = actual page dimensions
         '--------------------------------------------------------------------------
         GOSUB printerData
         hdc = GetDC(CBHNDL)
         xppi = GetDeviceCaps(hdc, %LOGPIXELSX)
         yppi = GetDeviceCaps(hdc, %LOGPIXELSY)
         nHt = .90 * GetDeviceCaps(hdc, %VERTRES) - 90   'dialog height in pixels
         nWi = (pageWi/pageHt) * (xppi / yppi) * nHt     'dialog width in pixels
         x = MAX(510, nWi + 60)
         DIALOG SET CLIENT CBHNDL, x, nHt + 60
         DIALOG SET LOC CBHNDL, 100, 10
         DeleteDC hdc
         
         'prepare hidden scroll bars -----------------------------------------------
         nx = (x - nWi - 9)/2: ny = 30 
         CONTROL SET SIZE CBHNDL, %IDC_VScroll, 18, nHt
         CONTROL SET LOC CBHNDL, %IDC_VScroll, nx + nWi, ny
         CONTROL SET SIZE CBHNDL, %IDC_HScroll, nWi, 18
         CONTROL SET LOC CBHNDL, %IDC_HScroll, nx, nHt + ny
         CONTROL SHOW STATE CBHNDL, %IDC_VScroll, %SW_HIDE
         CONTROL SHOW STATE CBHNDL, %IDC_HScroll, %SW_HIDE
         CONTROL HANDLE CBHNDL, %IDC_VScroll TO hVScroll
         CONTROL HANDLE CBHNDL, %IDC_HScroll TO hHScroll
         
         'create memory bitmap ----------------------------------------------------------
         memdc = CreateCompatibleDC(hPrnDC)
         hBmp = CreateCompatibleBitmap(hPrnDC, xp, yp)
         SelectObject memdc, hBmp 
         
         'initialize info for DIB (device independent bitmap)
         bmInfo.bmiHeader.biSize = SIZEOF(bmInfo.bmiHeader)
         bmInfo.bmiHeader.biWidth = xp
         bmInfo.bmiHeader.biHeight = yp
         bmInfo.bmiHeader.biPlanes = 1
         bmInfo.bmiHeader.biBitCount = 1 'monochrome
         bmInfo.bmiHeader.biCompression = %BI_RGB
         bmInfo.bmiColors(0).rgbBlue = 255
         bmInfo.bmiColors(0).rgbGreen = 255
         bmInfo.bmiColors(0).rgbRed = 255
         bmInfo.bmiColors(1).rgbBlue = 0
         bmInfo.bmiColors(1).rgbGreen = 0
         bmInfo.bmiColors(1).rgbRed = 0
         
         'create string for DIB memory space [bmBits]
         'and calculate size needed for it [bmSize]
         bmBits = STRING$(SIZEOF(BITMAPINFOHEADER), 0)
         bmSize = xp  
         bmSize = (bmSize + 1) / 8
         bmSize = ((bmSize + 3) / 4) * 4
         bmSize = bmSize * yp
         bmBits = bmBits + STRING$(bmSize, 0)
         bitsPtr = STRPTR(bmbits) + SIZEOF(BITMAPINFOHEADER)
         
         'initialize top controls for specifying pages to preview
         zoom = 1: x = 0: y = 0
         numPages = printRTF(memdc, -1, 0, -1)
         IF numPages THEN 
            nPage = 1: CONTROL SET TEXT hPreviewDlg, %IDC_PageNo, " 1": GOSUB previewPage
         END IF
         CONTROL SET TEXT hPreviewDlg, %IDC_NumPages, "of" + STR$(numPages) + " pages"
         r.nLeft = nx: r.nTop = ny
         r.nRight = r.nLeft + nWi: r.nBottom = r.nTop + nHt
         CONTROL SEND CBHNDL, %IDC_PageNo, %EM_SETSEL, -1, 0
         CONTROL SET FOCUS CBHNDL, %IDC_Printers  'PageNo 
         notPrinted = 1
      CASE %WM_PAINT
         hdc = BeginPaint(CBHNDL, ps)
         result = StretchDIBits(hdc, nx, ny, nWi, nHt, x, y, xp/zoom, yp/zoom, _
                  BYVAL bitsPtr, BYVAL VARPTR(bmInfo), %DIB_RGB_COLORS, %SRCCOPY)
         EndPaint CBHNDL, ps
      CASE %WM_COMMAND
         IF CBCTL = %IDC_Fwd THEN
            IF nPage < numPages THEN INCR nPage: GOSUB previewPage
         ELSEIF CBCTL = %IDC_Bwd THEN 
            IF nPage > 1 THEN DECR nPage: GOSUB previewPage
         ELSEIF CBCTL = %IDOK THEN 
            CONTROL GET TEXT CBHNDL, %IDC_PageNo TO s
            IF VAL(s) THEN
               nPage = MAX(1, MIN(VAL(s), numPages))
               CONTROL SET TEXT CBHNDL, %IDC_PageNo, STR$(nPage)
               IF nPage <> lastPage THEN
                  lastPage = nPage: zoom = 2.25
                  GOSUB previewPage
               END IF 
            END IF
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL      
         ELSEIF CBCTL = %IDC_Zoom THEN
            zoom = 1.5 * zoom: IF zoom > 2.25 THEN zoom = 1
            IF zoom > 1 THEN 
               CONTROL SHOW STATE CBHNDL, %IDC_VScroll, %SW_SHOW
               CONTROL SHOW STATE CBHNDL, %IDC_HScroll, %SW_SHOW
               si.cbSize = LEN(si)
               si.fMask  = %SIF_ALL
               si.nPage = (1 - 1/zoom)*yp/4
               si.nMax  = 5 * si.nPage
               si.nPos  = 0
               SetScrollInfo hVScroll, %SB_CTL, si, 1
               ssi.cbSize = LEN(ssi)
               ssi.fMask  = %SIF_ALL
               ssi.nPage = (1 - 1/zoom)*xp/4
               ssi.nMax  = 5 * ssi.nPage
               ssi.nPos  = 0
               SetScrollInfo hHScroll, %SB_CTL, ssi, 1
               x = 0: y = 4 * si.nPage
            ELSE
               x = 0: y = 0
               CONTROL SHOW STATE CBHNDL, %IDC_VScroll, %SW_HIDE
               CONTROL SHOW STATE CBHNDL, %IDC_HScroll, %SW_HIDE
            END IF 
            InvalidateRect CBHNDL, r, 0
         ELSEIF CBCTL = %IDC_Print THEN
            pageNo = nPage
            printFile
            IF printerChanged THEN 
               DeleteDC memdc
               DeleteObject hBmp
               GOSUB printerData
            END IF
         ELSEIF CBCTL = %IDC_Printers AND CBCTLMSG = %CBN_SELCHANGE THEN
            COMBOBOX GET TEXT CBHNDL, %IDC_Printers TO printerName
            hPrnDC = getPrinterDC(printerName)
            DeleteDC memdc: DeleteObject hBmp
            SendMessage CBHNDL, %WM_INITDIALOG, 0, 0 'ver 2.70
         ELSE
            EXIT FUNCTION
         END IF      
         IF zoom > 1 AND CBCTL < %IDC_Zoom THEN
            zoom = 2.25: DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_Zoom, 0
         END IF
         IF CBCTL < %IDC_Print THEN 'clear visible focus of buttons pressed
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END IF
      CASE %WM_VSCROLL
         SELECT CASE LOWRD(CBWPARAM)
            'note that DIB rows are numbered bottom to top
            CASE %SB_LINEDOWN, %SB_PAGEDOWN
               IF si.nPos < si.nMax - si.nPage THEN
                  si.nPos = si.nPos + si.nPage: y = y - si.nPage
               END IF
            CASE %SB_LINEUP, %SB_PAGEUP
               IF si.nPos > si.nMin THEN
                  si.nPos = si.nPos - si.nPage: y = y + si.nPage
               END IF
            CASE %SB_THUMBTRACK
               si.nPos = MIN(HIWRD(CBWPARAM), si.nMax - si.nPage): y = 4 * si.nPage - si.nPos
            CASE ELSE
               EXIT FUNCTION
         END SELECT
         InvalidateRect CBHNDL, r, 0
         si.cbSize = SIZEOF(si)
         si.fMask = %SIF_POS OR %SIF_PAGE
         SetScrollInfo hVScroll, %SB_CTL, si, 1
      CASE %WM_HSCROLL
         SELECT CASE LOWRD(CBWPARAM)
            CASE %SB_LINEDOWN, %SB_PAGEDOWN
               IF ssi.nPos < ssi.nMax - ssi.nPage THEN
                  ssi.nPos = ssi.nPos + ssi.nPage: x = x + ssi.nPage
               END IF
            CASE %SB_LINEUP, %SB_PAGEUP
               IF ssi.nPos > ssi.nMin THEN
                  ssi.nPos = ssi.nPos - ssi.nPage: x = x - ssi.nPage
               END IF
            CASE %SB_THUMBTRACK
               ssi.nPos = MIN(HIWRD(CBWPARAM), ssi.nMax - ssi.nPage): x = ssi.nPos
            CASE ELSE
               EXIT FUNCTION
         END SELECT
         InvalidateRect CBHNDL, r, 0 
         ssi.cbSize = SIZEOF(ssi)
         ssi.fMask = %SIF_POS OR %SIF_PAGE
         SetScrollInfo hHScroll, %SB_CTL, ssi, 1
      CASE %WM_DESTROY
         DeleteDC memdc
         DeleteObject hBmp
         DIALOG SHOW STATE hDlg, %SW_SHOW
         IF finish > start THEN
            putRichEditText hEdit, savText
            IF notPrinted THEN SendMessage hEdit, %EM_SETSEL, start - 1, finish - 1
            SendMessage(hEdit, %EM_SETMODIFY, fileChanged, 0)
         END IF
   END SELECT
   EXIT FUNCTION

printerData:   
   hPrnDC = getPrinterDC(printerName)
   IF hPrnDC = 0 THEN
      CONTROL SET TEXT hPreviewDlg, %IDC_PageNo, ""
      CONTROL SET TEXT hPreviewDlg, %IDC_NumPages, "of" + " 0 pages"
      MSGBOX "Printer not found", %MB_ICONWARNING, "Printer Error": RETURN
   END IF
   xp = GetDeviceCaps(hPrnDC, %PHYSICALWIDTH)
   yp = GetDeviceCaps(hPrnDC, %PHYSICALHEIGHT)
   pageWi = xp / GetDeviceCaps(hPrnDC, %LOGPIXELSX)
   pageHt = yp / GetDeviceCaps(hPrnDC, %LOGPIXELSY)
   prnWi = GetDeviceCaps(hPrnDC, %HORZRES) / GetDeviceCaps(hPrnDC, %LOGPIXELSX)
   prnHt  = GetDeviceCaps(hPrnDC, %VERTRES) / GetDeviceCaps(hPrnDC, %LOGPIXELSY)
   IF prnOrientation = 2 THEN 'landscape
      SWAP pageWi, pageHt
      SWAP prnWi, prnHt
      SWAP xp, yp
   END IF
   nonPrnLeft = GetDeviceCaps(hPrnDC, %PHYSICALOFFSETX) / GetDeviceCaps(hPrnDC, %LOGPIXELSX)
   nonPrnTop = GetDeviceCaps(hPrnDC, %PHYSICALOFFSETY) / GetDeviceCaps(hPrnDC, %LOGPIXELSY)
   nonPrnRight = pageWi - prnWi - nonPrnLeft
   nonPrnBottom = pageHt - prnHt - nonPrnTop
   RETURN

previewPage:
   IF nPage THEN
      PatBlt memdc, 0, 0, xp, yp, %PATCOPY
      printRTF memdc, 0, pageEnd(nPage - 1), pageEnd(nPage)
      GetDIBits(memDC, hBmp, 0, yp, BYVAL bitsPtr, BYVAL VARPTR(bmInfo), %DIB_RGB_COLORS)
      InvalidateRect CBHNDL, r, 0: lastPage = nPage
      CONTROL SET TEXT CBHNDL, %IDC_PageNo, STR$(MIN(nPage, numPages))   
   END IF
   RETURN      
END FUNCTION 

FUNCTION getPrinterDC(prName AS STRING) AS LONG
   LOCAL n, hPrinter, needed AS LONG
   LOCAL dm AS STRING, sz AS ASCIIZ*128
   DeleteDC hPrnDC
   sz = prName
   IF OpenPrinter(sz, hPrinter, BYVAL %NULL) THEN
      'First call to see how big the DEVMODE structure needs to be 
      needed = DocumentProperties(0, hPrinter, sz, BYVAL %NULL, BYVAL %NULL, 0)
      dm = SPACE$(needed): pDevMode = STRPTR(dm): n = %DM_OUT_BUFFER 
      DocumentProperties 0, hPrinter, sz, BYVAL pDevMode, BYVAL %NULL, n 
      IF prnOrientation = 2 THEN n = %DMORIENT_LANDSCAPE ELSE n = %DMORIENT_PORTRAIT
      @pDevMode.dmOrientation = n: n = %DM_OUT_BUFFER OR %DM_IN_BUFFER
      DocumentProperties 0, hPrinter, sz, BYVAL pDevMode, BYVAL pDevMode, n
      FUNCTION = CreateDC("WINSPOOL", sz, BYVAL %NULL, BYVAL pDevMode)
   END IF
END FUNCTION

FUNCTION printRTF(hdc AS LONG, prn AS LONG, cpMin AS LONG, cpMax AS LONG) AS LONG
   'prn > 0 to print pages
   'prn = 0 to preview page
   'prn < 0 to define pages
   'range of printing:
   'cpMin = first character index
   'cpMax = last character index 
   'cpMin = -1 for printing selected text
   'cpMax = -1 for printing all pages
   '---------------------------------------------------------------------------
   LOCAL fr AS FORMATRANGE, hEd, lRet AS LONG
   LOCAL di AS DOCINFO, zString AS ASCIIZ * 255
   LOCAL iTextOut, iTextAmt, nPage, nStyle AS LONG 
   LOCAL lMargin, tMargin, rMargin, bMargin AS SINGLE
   
   fr.hdc            = hdc
   fr.hdcTarget      = hdc
   fr.rcPage.nLeft   = 0
   fr.rcPage.nTop    = 0
   fr.rcPage.nRight  = prnWi * 1440.0
   fr.rcPage.nBottom = prnHt * 1440.0
   
   lMargin = leftMargin - nonPrnLeft
   tMargin = topMargin - nonPrnTop
   rMargin = rightMargin - nonPrnRight
   bMargin = bottomMargin - nonPrnBottom 
   
   fr.rc.nLeft   = 1440.0 * lMargin
   fr.rc.nTop    = 1440.0 * tMargin
   fr.rc.nRight  = 1440.0 * (prnWi - rMargin)
   fr.rc.nBottom = 1440.0 * (prnHt - bMargin)

   'fill docInfo structure, di
   di.cbSize         = SIZEOF(DOCINFO)
   zString           = "RTF Printer"
   di.lpszDocName    = VARPTR(zString)
   di.lpszOutput     = %NULL
   
   hEd = hEdit: iTextAmt = cpMax
   IF cpMin < 0 THEN 'process selected text only
      hEd = hEditSel: cpMin = 0 
      iTextAmt = SendMessage(hEd, %WM_GETTEXTLENGTH, 0, 0)
   ELSEIF cpMax < 0 THEN 'process entire text
      iTextAmt = SendMessage(hEd, %WM_GETTEXTLENGTH, 0, 0)
   END IF 
   fr.chrg.cpmin = cpMin: fr.chrg.cpmax = iTextAmt
   IF prn > 0 THEN
      printOk = 1
      lRet = SetAbortProc(hdc, CODEPTR(AbortFcn))
      nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
      DIALOG NEW PIXELS, 0, "Printing...", , , 150, 90, nStyle TO hAbortDlg
      CONTROL ADD LABEL, hAbortDlg, %IDC_PageNo, "Printing page", 10, 15, 120, 15
      CONTROL ADD BUTTON, hAbortDlg, %IDCANCEL, "Cancel", 40, 40, 70, 40
      MOUSEPTR 1
      DIALOG SHOW MODELESS hAbortDlg CALL abortDlgProc
      StartDoc hdc, di
   END IF
   nPage = prn - 1: IF prn < 0 THEN numPages = 0
   DO 
      IF prn > 0 THEN 'check if another page is to be printed 
         IF nPage < numPages THEN
            INCR nPage
            CONTROL SET TEXT hAbortDlg, %IDC_PageNo, "Printing page" + STR$(nPage)
            SLEEP 1000 'allow a second to cancel print 
          END IF
         iTextOut = SendMessage(hEd, %EM_FORMATRANGE, 0, VARPTR(fr))
         IF (iTextOut < fr.chrg.cpmin) OR (iTextOut > fr.chrg.cpmax) THEN EXIT DO 
         StartPage hdc
      END IF
      iTextOut = SendMessage(hEd, %EM_FORMATRANGE, prn + 1, VARPTR(fr))
      IF prn > 0 THEN Endpage hdc
      'MSGBOX STR$(iTextOut)+"  "+STR$(fr.chrg.cpmin)+"  "+STR$(fr.chrg.cpmax)+"  "+STR$(iTextAmt)
      'IF (iTextOut < fr.chrg.cpmin) OR (iTextOut > fr.chrg.cpmax) THEN EXIT DO
      IF (iTextOut <= fr.chrg.cpmin) OR (iTextOut > fr.chrg.cpmax) THEN EXIT DO 'ver 2.62
      IF prn < 0 THEN INCR numPages: pageEnd(numPages) = iTextOut
      fr.chrg.cpmin = iTextOut: fr.chrg.cpmax = iTextAmt
   LOOP WHILE iTextOut < iTextAmt
   
   ' Clean up the Richedit control and finish printing
   SendMessage hEd, %EM_FORMATRANGE, 0, BYVAL %NULL
   IF prn > 0 THEN 
      EndDoc hdc: IF printOk THEN DIALOG END hAbortDlg
   END IF
   FUNCTION = numPages 
END FUNCTION

FUNCTION AbortFcn(BYVAL hdc AS LONG, BYVAL iCode AS LONG) AS LONG
   LOCAL Msg AS TAGMSG
   'provide a message "pump" to allow abort during GDI print spooling
   WHILE PeekMessage(Msg, BYVAL %NULL, 0, 0, %PM_REMOVE)
      IF hAbortDlg AND ISFALSE(IsDialogMessage(hAbortDlg, Msg)) THEN
         TranslateMessage Msg
         DispatchMessage Msg
      END IF
   WEND
   FUNCTION = printOk
END FUNCTION

CALLBACK FUNCTION abortDlgProc()
   SELECT CASE CBMSG
      CASE %WM_COMMAND
        IF CBCTL = %IDCANCEL THEN
           printOk = 0: DIALOG END hAbortDlg
           MSGBOX "Print cancelled", %MB_ICONINFORMATION, "Print Status" + SPACE$(10)
        END IF   
   END SELECT
END FUNCTION

SUB printFile()
   LOCAL pd AS PRINTDLGAPI, cr AS CHARRANGE, pDevNames AS DEVNAMES PTR
   LOCAL start, finish, i, j, k, nStyle, hdc, pDest AS LONG
   LOCAL s, txt, printerNameIn AS STRING
   LOCAL sz AS ASCIIZ * 128, psz AS ASCIIZ PTR
   
   txt = getRichEditText(hEdit)
   IF LEN(txt) = 0 THEN EXIT SUB
   'setup the print dialog --------------------------------------------
   pd.lStructSize = LEN(pd)
   pd.Flags = %PD_RETURNDC OR %PD_HIDEPRINTTOFILE
   SendMessage hEdit, %EM_EXGETSEL, 0, VARPTR(cr)
   start = cr.cpMin + 1: finish = cr.cpMax + 1
   notPrinted = 1
   IF LEN(printerName) THEN 'preselect current printer
      sz = printerName
      pd.hDevMode = GlobalAlloc (%GMEM_MOVEABLE OR %GMEM_ZEROINIT, SIZEOF(@pDevNames) + 128)
      pd.hDevNames = GlobalAlloc (%GMEM_MOVEABLE OR %GMEM_ZEROINIT, SIZEOF(@pDevMode))
      pd.lStructSize = LEN(pd)
      pDevNames = GlobalLock(pd.hDevNames)
      @pDevNames.wDeviceOffset = SIZEOF (@pDevNames)
      pDest = pDevnames + SIZEOF(@pDevNames)
      CopyMemory pDest, VARPTR(sz), LEN(sz)
      GlobalUnlock pd.hDevNames
   ELSE 'get default printerName and define pages
      GetProfileString "WINDOWS", "DEVICE", "", sz, 127
      s = TRIM$(PARSE$(sz, ",", 1)): printerName = s
      hdc = getPrinterDC(s)
      pageWi = GetDeviceCaps(hdc, %PHYSICALWIDTH)/GetDeviceCaps(hdc, %LOGPIXELSX)
      pageHt = GetDeviceCaps(hdc, %PHYSICALHEIGHT)/GetDeviceCaps(hdc, %LOGPIXELSY)
      prnWi = GetDeviceCaps(hdc, %HORZRES)/GetDeviceCaps(hdc, %LOGPIXELSX)
      prnHt  = GetDeviceCaps(hdc, %VERTRES)/GetDeviceCaps(hdc, %LOGPIXELSY)
      IF prnOrientation = 2 THEN 'landscape 
         SWAP pageWi, pageHt
         SWAP prnWi, prnHt
      END IF
      nonPrnLeft = GetDeviceCaps(hdc, %PHYSICALOFFSETX)/GetDeviceCaps(hdc, %LOGPIXELSX)
      nonPrnTop = GetDeviceCaps(hdc, %PHYSICALOFFSETY)/GetDeviceCaps(hdc, %LOGPIXELSY)
      nonPrnRight = pageWi - prnWi - nonPrnLeft
      nonPrnBottom = pageHt - prnHt - nonPrnTop 
      numPages = printRTF(hdc, -1, 0, -1)
      DeleteDC hdc
   END IF
   IF numPages > 1 THEN
      pd.nFromPage = 1: pd.nToPage = numPages
      pd.nMinPage = 1: pd.nMaxPage = numPages
      IF pageNo THEN
         pd.nFromPage = pageNo: pd.nToPage = pageNo
      END IF
   END IF
   
   IF finish > start THEN 'create hidden rich edit control and copy selection to it
      nStyle = %WS_CHILD  OR %WS_CLIPCHILDREN OR %WS_VISIBLE OR %ES_MULTILINE OR _
               %WS_VSCROLL OR %ES_AUTOVSCROLL OR %ES_WANTRETURN OR %ES_NOHIDESEL
      CONTROL ADD ctrlName, hDlg, %IDC_PrnSelect, "", 0, 0, 500, 460, nStyle
      CONTROL SHOW STATE hDlg, %IDC_PrnSelect, %SW_HIDE
      CONTROL HANDLE hDlg, %IDC_PrnSelect TO hEditSel
      SendMessage hEdit, %WM_COPY, 0, 0
      SendMessage hEditSel, %WM_PASTE, 0, 0
      pd.Flags = pd.Flags OR %PD_ALLPAGES OR %PD_SELECTION OR %PD_NOPAGENUMS
   ELSE
      pd.Flags = pd.Flags OR %PD_ALLPAGES OR %PD_PAGENUMS OR %PD_NOSELECTION
   END IF
   
   printerNameIn = printerName
   'pd.hWndOwner = hDlg
   DeleteDC hPrnDC
   IF pDevMode THEN pd.hDevMode = pDevMode
   IF PrintDlg(pd) THEN 'call print dialog to select printer -------------------------
      pDevNames = GlobalLock(pd.hDevNames)
      psz = pDevNames + @pDevNames.wDeviceOffset: printerName = @psz
      GlobalUnlock pd.hDevnames
      printerChanged = 0: hPrnDC = pd.hDC
      IF printerName <> printerNameIn THEN 
         printerChanged = 1
         numPages = printRTF(pd.hDC, -1, 0, -1) 'redefine pages
      END IF
      IF (pd.Flags AND %PD_SELECTION) THEN 'print selection
         i = -1: j = 0
      ELSEIF (pd.Flags AND %PD_PAGENUMS) THEN 'print specified pages
         i = pageEnd(pd.nFromPage - 1): j = pageEnd(pd.nToPage): k = pd.nFromPage
      ELSE 'print all pages
         i = 0: j = -1
      END IF
      SetCursor LoadCursor(%NULL, BYVAL %IDC_WAIT)
      printRTF pd.hDC, MAX(k, 1), i, j: notPrinted = 0
      SetCursor LoadCursor(%NULL, BYVAL %IDC_ARROW)
      SendMessage hEdit, %EM_SETSEL, -1, 0
      IF pd.hDevMode THEN GlobalFree pd.hDevMode
      IF pd.hDevNames THEN GlobalFree pd.hDevNames
   END IF
   IF finish > start THEN CONTROL KILL hDlg, %IDC_PrnSelect
END SUB

'-------------------------------------------------------------------------------------
'myInput
'-------------------------------------------------------------------------------------
FUNCTION myInput(OPT BYVAL prompt AS STRING, BYVAL ti AS STRING) AS STRING
   LOCAL hInput AS LONG, s AS STRING, ps AS STRING PTR
   DIALOG NEW 0, ti, , , 130, 85, %WS_SYSMENU OR %DS_MODALFRAME TO hInput
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, 60, 12
   CONTROL ADD TEXTBOX, hInput, %IDC_myInput, STR$(tabSpaces), 70, 15, 25, 12
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", 60, 40, 50, 20
   ps = STRPTR(s): DIALOG SET USER hInput, 1, ps
   DIALOG SHOW MODAL hInput, CALL myInputProc 
   FUNCTION = @ps
END FUNCTION 

CALLBACK FUNCTION myInputProc()
   LOCAL ps AS STRING PTR
   IF CBMSG = %WM_COMMAND AND (CBCTL = %IDOK OR CBCTL = %IDCANCEL) THEN 
      DIALOG GET USER CBHNDL, 1 TO ps
      IF CBCTL = %IDOK THEN CONTROL GET TEXT CBHNDL, %IDC_myInput TO @ps
      DIALOG END CBHNDL
   END IF 
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
CALLBACK FUNCTION aboutProc() AS LONG
   LOCAL n AS LONG, url, email AS ASCIIZ*64
   STATIC hUlineFont AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      hUlineFont = makeFont("MS Sans Serif", 10, "u")
   CASE %WM_CTLCOLORSTATIC
      n = GetDlgCtrlId(CBLPARAM)
      IF n = %IDC_Email OR n = %IDC_WebAddr THEN
         SelectObject CBWPARAM, hUlineFont
         CONTROL SET COLOR CBHNDL, n, %BLUE, -1
      END IF
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= %IDC_Email THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND"): FUNCTION = 1 
      END IF 
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN 
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDC_Email THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)   
      ELSEIF CBCTL = %IDC_WebAddr THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   CASE %WM_DESTROY
      DeleteObject hUlineFont
   END SELECT
END FUNCTION

SUB About
   LOCAL hAbout AS LONG, s AS STRING
   s = "Text editor for Windows" + $CRLF _
     + "Version number " + $verNo + " - Free distribution" + $CRLF _
     + "by Charles G. Dietz" + $CRLF + $CRLF  _
     + "I wish to acknowledge the very helpful" + $CRLF _
     + "rich text code written by Borje Hagster."
   DIALOG NEW hDlg,"About myEditor",,, 200, 160, %WS_SYSMENU OR %DS_MODALFRAME TO hAbout
   CONTROL ADD LABEL, hAbout, 999, s, 50, 10, 140, 50, %SS_NOPREFIX
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, %IDC_Email, s, 50, 70, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, %IDC_WebAddr, s, 50, 85, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD BUTTON, hAbout, %IDOK, "OK", 85, 110, 50, 25
   CONTROL ADD IMAGE, hAbout, -1, "editor", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB
