'-----------------------------------------------------------------------------------------
'Notes:
'  hFont is maintained globally for text files --> fontName, fontsize, and fontAttrs
'  setFontName(), setFontSize(), and setEffect() is used for RTF files
'
'Ver 2.40 01-16-07
'    - allow TAB for inserting spaces
'    - specify number of tab spaces under Format menu
'Ver 2.41 01-18-07
'    - corrected minor bug in preferences (saving to myEditor.ini)
'Ver 2.42 01-20-07
'    - allow landscape printing using pDevMode pointer
'      affected pageSetup, printPreview, and printFile
'    - corrected minor printing bugs associated with margins and dead areas
'    - corrected minor bug for saveAs rtf file
'ver 2.43 01-24-07
'    - allow print preview for selected text
'    - increased dimension to pageEnd(1000)
'    - added close button to print preview
'ver 2.44 01-25-07
'    - enabled print cancelling
'    - added tab spaces to preferences 
'    - improved inputting tab spaces
'    - improved About dialog
'ver 2.45 03-13-07
'    - corrected paste problem (some Word Perfect selections do not display properly) 
'    - added hidden textbox, paste to it first, then select all and cut
'    - finally, paste to rich textbox
'ver 2.46 03-13-07
'    - better way to make ver 2.45 paste corrections when rtfFile = 0 (%WM_PASTE)
'    - call clipboard_SetText clipboard_GetText instead of adding hidden textbox
'ver 2.47 03-21-07
'    - minor correction to Print Preview - printRTF()... one liner did not preview
'ver 2.48 03-22-07
'    - minor correction to About... email and website not underlined in Windows 98
'ver 2.49 03-24-07
'    - corrected problems associated with Preferences
'ver 2.51 04-14-07
'    - recompute pages when selected printer is not the default printer
'    - added combobox to select printer for more accurate print preview
'    - corrected print/print-preview problem of pages leaving off 1st character 
'ver 2.52 05-09-07
'    - corrected font sizes (added CASE %IDC_FontNames for changes)
'    - identify 'RTF tags' menu item with checkmark
'ver 2.53 05-12-07
'    - improved code by using GOSUB printerData to change printers in print preview 
'    - corrected code error for Ok command in fontDlgProc()
'ver 2.60 05-24-07
'    - corrected saveAs error converting rtf file to text file
'    - made fontName and fontSize as global variables
'ver 2.61 05-25-07
'    - added SaveDlgHookProc to match file extension with file type
'    - added Close to File menu
'ver 2.62 10-24-07
'    - corrected print and preview problem in printRTF()
'ver 2.70 04-19-08
'    - added strip codes feature
'    - corrected and improved print preview
'ver 2.71 08-15-08
'    - corrected problem changing font size in text files
'ver 2.72 09-12-08
'    - improved routine to toggle wordWrap view
'    - corrected problem with changing printers in print preview
'ver 2.80 12-15-08
'    - correct preview problem in Vista (revised stretchBlt --> stretchDIBits)
'ver 2.81 10-26-09
'    - correct a few problems (focus for Find, I think)
'-----------------------------------------------------------------------------------------

%IDM_NewTxt      = 101
%IDM_NewRTF      = 102
%IDM_Close       = 103
%IDM_Open        = 104
%IDM_Save        = 105
%IDM_SaveAs      = 106
%IDM_PgSetup     = 107
%IDM_Preview     = 108
%IDM_Print       = 109
%IDM_Exit        = 110
%IDM_Undo        = 201
%IDM_Cut         = 202
%IDM_Copy        = 203
%IDM_Paste       = 204
%IDM_SelAll      = 205
%IDM_Fonts       = 301
%IDM_TabSpaces   = 302
%IDM_Bullets     = 303
%IDM_Paragraphs  = 304
%IDM_WordWrap    = 401
%IDM_Strip       = 402
%IDM_RTFTags     = 403
%IDM_Preferences = 404
%IDM_Find        = 501
%IDM_FindNext    = 502
%IDM_FindPrev    = 503
%IDM_Replace     = 504
%IDM_Content     = 600
%IDM_About       = 601
%IDC_Text        = 701
%IDC_PrnSelect   = 702
%IDC_FontNames   = 703
%IDC_FontSizes   = 704
%IDC_Bold        = 705
%IDC_Italic      = 706
%IDC_ULine       = 707
%IDC_Color       = 708
%IDC_ColorView   = 709
%IDC_BGColor     = 710
%IDC_BGColorView = 711
%IDC_LeftIndent  = 751
%IDC_RightIndent = 752
%IDC_FirstLine   = 753
%IDC_Align       = 754
%IDC_Listbox     = 801
%IDC_Status      = 802
%IDC_Preview     = 803
%IDC_Fwd         = 804
%IDC_Bwd         = 805
%IDC_PageNo      = 806
%IDC_NumPages    = 807
%IDC_Zoom        = 808
%IDC_Print       = 809
%IDC_Printers    = 810
%IDC_VScroll     = 811
%IDC_HScroll     = 812
%IDC_SaveFont    = 901
%IDC_EditorSize  = 902
%IDC_Tabspaces   = 903
%IDC_WordWrap    = 904
%IDC_FindDlg     = 905
%IDC_Backup      = 906
%IDC_myInput     = 1000
%IDC_nPage       = 1001
%IDC_Email       = 1002
%IDC_WebAddr     = 1003

GLOBAL hDlg AS DWORD
GLOBAL hMenu AS DWORD
GLOBAL hAccel AS DWORD
GLOBAL hFileMenu AS DWORD
GLOBAL hEditMenu AS DWORD
GLOBAL hFmtMenu AS DWORD 
GLOBAL hViewMenu AS DWORD
GLOBAL hSearchMenu AS DWORD
GLOBAL hHelpMenu AS DWORD
GLOBAL hMouseMenu AS DWORD
GLOBAL hFont AS DWORD
GLOBAL hStatusbar AS DWORD
GLOBAL hPreviewDlg AS DWORD
GLOBAL hPrnDC AS LONG
GLOBAL printerChanged AS LONG
GLOBAL hFontDlg AS DWORD
GLOBAL hCurrentDlg AS DWORD
GLOBAL hEdit, hEditSel AS DWORD
GLOBAL gOrigEditProc AS DWORD
GLOBAL rtfFile AS LONG
GLOBAL fileFmt AS DWORD
GLOBAL thisFile AS STRING
GLOBAL fileChanged AS BYTE
GLOBAL fontName AS STRING
GLOBAL fontSize, textColor, scrnColor AS LONG
GLOBAL wordwrap, findDlg, backup, tabSpaces AS LONG 
GLOBAL nonPrnLeft, nonPrnTop, nonPrnRight, nonPrnBottom AS SINGLE
GLOBAL leftMargin, rightMargin, topMargin, bottomMargin AS SINGLE
GLOBAL prnWi, prnHt, pageWi, pageHt AS SINGLE
GLOBAL leftIndent, rightIndent, firstLine AS LONG
GLOBAL hAbortDlg, printOk, notPrinted AS LONG
GLOBAL prnOrientation, numPages, pageNo AS LONG
GLOBAL pDevMode AS DEVMODE PTR
GLOBAL editorWi, editorHt AS LONG
GLOBAL ctrlName AS STRING
GLOBAL printerName AS STRING
GLOBAL pageEnd() AS LONG
GLOBAL gLF AS LOGFONT

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
DECLARE FUNCTION subClassEditProc(BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG) AS LONG
DECLARE FUNCTION MakeFont(BYVAL STRING, BYVAL LONG, OPT BYVAL STRING) AS DWORD
DECLARE FUNCTION EnumCharSet(ENUMLOGFONT, NEWTEXTMETRIC, BYVAL LONG, LONG) AS LONG
DECLARE FUNCTION putRichEditText(BYVAL hEd AS DWORD, BYVAL STRING) AS LONG
DECLARE FUNCTION getRichEditText(BYVAL DWORD) AS STRING
DECLARE FUNCTION myFindReplace(LONG, OPT BYVAL LONG) AS LONG
DECLARE FUNCTION myFind(LONG, STRING, LONG, LONG, LONG) AS LONG 
DECLARE FUNCTION fitLongFileName(STRING, LONG, LONG) AS STRING
DECLARE FUNCTION printRTF(LONG, LONG, LONG, LONG) AS LONG
DECLARE FUNCTION enumFontFamProc(LOGFONT, TEXTMETRIC, BYVAL LONG, LONG) AS LONG
DECLARE FUNCTION fontSizeProc (LOGFONT, TEXTMETRIC, BYVAL LONG, DWORD) AS LONG
DECLARE FUNCTION quitProgram() AS LONG 
DECLARE FUNCTION getFontName() AS STRING
DECLARE FUNCTION getFontsize() AS LONG 
DECLARE FUNCTION getEffect() AS LONG
DECLARE FUNCTION getColor() AS LONG
DECLARE FUNCTION getBGColor() AS LONG
DECLARE FUNCTION Clipboard_GetText() AS STRING
DECLARE FUNCTION myInput(OPT BYVAL STRING, BYVAL STRING) AS STRING
DECLARE FUNCTION AbortFcn(BYVAL LONG, BYVAL LONG) AS LONG
DECLARE FUNCTION getPrinterDC(STRING) AS LONG
DECLARE SUB Clipboard_SetText(BYVAL STRING)
DECLARE SUB setJustify(LONG)
DECLARE SUB setEffect(BYVAL LONG)
DECLARE SUB setColor(BYVAL LONG, OPT BYVAL LONG)
DECLARE SUB setBGColor(BYVAL LONG, OPT BYVAL LONG)
DECLARE SUB setFontName(BYVAL STRING)
DECLARE SUB setFontSize(BYVAL LONG)
DECLARE SUB setIndent(LONG, LONG, LONG)
DECLARE SUB setBullets()
DECLARE SUB enumFontSizes(BYVAL STRING, BYVAL DWORD)
DECLARE SUB UpdateRTFControls()
DECLARE SUB fontDlg()
DECLARE SUB paragraphDlg()
DECLARE SUB printFile()
DECLARE SUB addMenubar()
DECLARE SUB addStatusbar()
DECLARE SUB openTheFile()
DECLARE SUB saveTheFile()
DECLARE SUB saveAsFile()
DECLARE SUB updateStatus(OPT BYVAL LONG)
DECLARE SUB pageSetup()
DECLARE SUB printPreview()
DECLARE SUB Preferences()
DECLARE SUB rtfEditor(LONG)
DECLARE SUB wordWrapView()
DECLARE SUB stripCodes()
DECLARE SUB about()

     